#ifndef FUNCTIONAL_CLASSES_HH
#define FUNCTIONAL_CLASSES_HH

// functional programming classes
// Copyright 2001 Anthony Williams

#include "functional_refholder.hh"

namespace functional
{
    // adapt another functor, e.g. pointer-to-function
    template<typename ReturnType,typename FunctionType>
    class FunctorAdaptor
    {
    public:
	typedef ReturnType return_type;

	FunctorAdaptor(FunctionType fun_):
	    fun(fun_)
	{}

	ReturnType operator()() const
	{
	    return fun();
	}
	template<typename Arg1>
	ReturnType operator()(const Arg1& a1) const
	{
	    return fun(a1);
	}
	template<typename Arg1,typename Arg2>
	ReturnType operator()(const Arg1& a1,const Arg2& a2) const
	{
	    return fun(a1,a2);
	}
	template<typename Arg1,typename Arg2,typename Arg3>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3) const
	{
	    return fun(a1,a2,a3);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4) const
	{
	    return fun(a1,a2,a3,a4);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5) const
	{
	    return fun(a1,a2,a3,a4,a5);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6) const
	{
	    return fun(a1,a2,a3,a4,a5,a6);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,a9);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14,typename Arg15>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14,const Arg15& a15) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15);
	}
    private:
	FunctionType fun;
    };

    // adapt pointer-to-member-function
    // pass object by pointer (or smart pointer)
    template<typename ReturnType,typename FunctionType>
    class MemberFunctionAdaptorObjectByPtr
    {
    public:
	typedef ReturnType return_type;

	MemberFunctionAdaptorObjectByPtr(FunctionType fun_):
	    fun(fun_)
	{}

	template<typename ObjectPtrType>
	ReturnType operator()(ObjectPtrType object) const
	{
	    return ((*object).*fun)();
	}
	template<typename ObjectPtrType,
		 typename Arg1>
	ReturnType operator()(ObjectPtrType object,
			      const Arg1& a1) const
	{
	    return ((*object).*fun)(a1);
	}
	template<typename ObjectPtrType,
		 typename Arg1,typename Arg2>
	ReturnType operator()(ObjectPtrType object,
			      const Arg1& a1,const Arg2& a2) const
	{
	    return ((*object).*fun)(a1,a2);
	}
	template<typename ObjectPtrType,
		 typename Arg1,typename Arg2,typename Arg3>
	ReturnType operator()(ObjectPtrType object,
			      const Arg1& a1,const Arg2& a2,const Arg3& a3) const
	{
	    return ((*object).*fun)(a1,a2,a3);
	}
	template<typename ObjectPtrType,
		 typename Arg1,typename Arg2,typename Arg3,typename Arg4>
	ReturnType operator()(ObjectPtrType object,
			      const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4) const
	{
	    return ((*object).*fun)(a1,a2,a3,a4);
	}
	template<typename ObjectPtrType,
		 typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5>
	ReturnType operator()(ObjectPtrType object,
			      const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5) const
	{
	    return ((*object).*fun)(a1,a2,a3,a4,a5);
	}
	template<typename ObjectPtrType,
		 typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6>
	ReturnType operator()(ObjectPtrType object,
			      const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6) const
	{
	    return ((*object).*fun)(a1,a2,a3,a4,a5,a6);
	}
	template<typename ObjectPtrType,
		 typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7>
	ReturnType operator()(ObjectPtrType object,
			      const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7) const
	{
	    return ((*object).*fun)(a1,a2,a3,a4,a5,a6,a7);
	}
	template<typename ObjectPtrType,
		 typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8>
	ReturnType operator()(ObjectPtrType object,
			      const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8) const
	{
	    return ((*object).*fun)(a1,a2,a3,a4,a5,a6,a7,a8);
	}
	template<typename ObjectPtrType,
		 typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9>
	ReturnType operator()(ObjectPtrType object,
			      const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9) const
	{
	    return ((*object).*fun)(a1,a2,a3,a4,a5,a6,a7,a8,a9);
	}
	template<typename ObjectPtrType,
		 typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10>
	ReturnType operator()(ObjectPtrType object,
			      const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10) const
	{
	    return ((*object).*fun)(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10);
	}
	template<typename ObjectPtrType,
		 typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11>
	ReturnType operator()(ObjectPtrType object,
			      const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11) const
	{
	    return ((*object).*fun)(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11);
	}
	template<typename ObjectPtrType,
		 typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12>
	ReturnType operator()(ObjectPtrType object,
			      const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12) const
	{
	    return ((*object).*fun)(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12);
	}
	template<typename ObjectPtrType,
		 typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13>
	ReturnType operator()(ObjectPtrType object,
			      const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13) const
	{
	    return ((*object).*fun)(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13);
	}
	template<typename ObjectPtrType,
		 typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14>
	ReturnType operator()(ObjectPtrType object,
			      const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14) const
	{
	    return ((*object).*fun)(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14);
	}
	template<typename ObjectPtrType,
		 typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14,typename Arg15>
	ReturnType operator()(ObjectPtrType object,
			      const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14,const Arg15& a15) const
	{
	    return ((*object).*fun)(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15);
	}
    private:
	FunctionType fun;
    };

    // pass object by reference
    template<typename ReturnType,typename FunctionType>
    class MemberFunctionAdaptorObjectByRef
    {
    public:
	typedef ReturnType return_type;

	MemberFunctionAdaptorObjectByRef(FunctionType fun_):
	    fun(fun_)
	{}

	template<typename ObjectRefType>
	ReturnType operator()(const ObjectRefType& object) const
	{
	    return (object.*fun)();
	}
	template<typename ObjectRefType,
		 typename Arg1>
	ReturnType operator()(const ObjectRefType& object,
			      const Arg1& a1) const
	{
	    return (object.*fun)(a1);
	}
	template<typename ObjectRefType,
		 typename Arg1,typename Arg2>
	ReturnType operator()(const ObjectRefType& object,
			      const Arg1& a1,const Arg2& a2) const
	{
	    return (object.*fun)(a1,a2);
	}
	template<typename ObjectRefType,
		 typename Arg1,typename Arg2,typename Arg3>
	ReturnType operator()(const ObjectRefType& object,
			      const Arg1& a1,const Arg2& a2,const Arg3& a3) const
	{
	    return (object.*fun)(a1,a2,a3);
	}
	template<typename ObjectRefType,
		 typename Arg1,typename Arg2,typename Arg3,typename Arg4>
	ReturnType operator()(const ObjectRefType& object,
			      const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4) const
	{
	    return (object.*fun)(a1,a2,a3,a4);
	}
	template<typename ObjectRefType,
		 typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5>
	ReturnType operator()(const ObjectRefType& object,
			      const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5) const
	{
	    return (object.*fun)(a1,a2,a3,a4,a5);
	}
	template<typename ObjectRefType,
		 typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6>
	ReturnType operator()(const ObjectRefType& object,
			      const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6) const
	{
	    return (object.*fun)(a1,a2,a3,a4,a5,a6);
	}
	template<typename ObjectRefType,
		 typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7>
	ReturnType operator()(const ObjectRefType& object,
			      const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7) const
	{
	    return (object.*fun)(a1,a2,a3,a4,a5,a6,a7);
	}
	template<typename ObjectRefType,
		 typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8>
	ReturnType operator()(const ObjectRefType& object,
			      const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8) const
	{
	    return (object.*fun)(a1,a2,a3,a4,a5,a6,a7,a8);
	}
	template<typename ObjectRefType,
		 typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9>
	ReturnType operator()(const ObjectRefType& object,
			      const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9) const
	{
	    return (object.*fun)(a1,a2,a3,a4,a5,a6,a7,a8,a9);
	}
	template<typename ObjectRefType,
		 typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10>
	ReturnType operator()(const ObjectRefType& object,
			      const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10) const
	{
	    return (object.*fun)(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10);
	}
	template<typename ObjectRefType,
		 typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11>
	ReturnType operator()(const ObjectRefType& object,
			      const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11) const
	{
	    return (object.*fun)(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11);
	}
	template<typename ObjectRefType,
		 typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12>
	ReturnType operator()(const ObjectRefType& object,
			      const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12) const
	{
	    return (object.*fun)(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12);
	}
	template<typename ObjectRefType,
		 typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13>
	ReturnType operator()(const ObjectRefType& object,
			      const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13) const
	{
	    return (object.*fun)(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13);
	}
	template<typename ObjectRefType,
		 typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14>
	ReturnType operator()(const ObjectRefType& object,
			      const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14) const
	{
	    return (object.*fun)(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14);
	}
	template<typename ObjectRefType,
		 typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14,typename Arg15>
	ReturnType operator()(const ObjectRefType& object,
			      const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14,const Arg15& a15) const
	{
	    return (object.*fun)(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15);
	}
    private:
	FunctionType fun;
    };
    
    // bind first argument
    template<typename ReturnType,typename FunctionType,typename Arg>
    class Binder1st
    {
    public:
	typedef ReturnType return_type;

	Binder1st(FunctionType fun_,Arg arg_):
	    fun(fun_),
	    arg(arg_)
	{}

	ReturnType operator()() const
	{
	    return fun(arg);
	}
	template<typename Arg1>
	ReturnType operator()(const Arg1& a1) const
	{
	    return fun(arg,a1);
	}
	template<typename Arg1,typename Arg2>
	ReturnType operator()(const Arg1& a1,const Arg2& a2) const
	{
	    return fun(arg,a1,a2);
	}
	template<typename Arg1,typename Arg2,typename Arg3>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3) const
	{
	    return fun(arg,a1,a2,a3);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4) const
	{
	    return fun(arg,a1,a2,a3,a4);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5) const
	{
	    return fun(arg,a1,a2,a3,a4,a5);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6) const
	{
	    return fun(arg,a1,a2,a3,a4,a5,a6);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7) const
	{
	    return fun(arg,a1,a2,a3,a4,a5,a6,a7);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8) const
	{
	    return fun(arg,a1,a2,a3,a4,a5,a6,a7,a8);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9) const
	{
	    return fun(arg,a1,a2,a3,a4,a5,a6,a7,a8,a9);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10) const
	{
	    return fun(arg,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11) const
	{
	    return fun(arg,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12) const
	{
	    return fun(arg,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13) const
	{
	    return fun(arg,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14) const
	{
	    return fun(arg,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14,typename Arg15>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14,const Arg15& a15) const
	{
	    return fun(arg,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15);
	}
    private:
	FunctionType fun;
	Arg arg;
    };
    
    // bind second argument
    template<typename ReturnType,typename FunctionType,typename Arg>
    class Binder2nd
    {
    public:
	typedef ReturnType return_type;

	Binder2nd(FunctionType fun_,Arg arg_):
	    fun(fun_),
	    arg(arg_)
	{}

	template<typename Arg1>
	ReturnType operator()(const Arg1& a1) const
	{
	    return fun(a1,arg);
	}
	template<typename Arg1,typename Arg2>
	ReturnType operator()(const Arg1& a1,const Arg2& a2) const
	{
	    return fun(a1,arg,a2);
	}
	template<typename Arg1,typename Arg2,typename Arg3>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3) const
	{
	    return fun(a1,arg,a2,a3);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4) const
	{
	    return fun(a1,arg,a2,a3,a4);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5) const
	{
	    return fun(a1,arg,a2,a3,a4,a5);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6) const
	{
	    return fun(a1,arg,a2,a3,a4,a5,a6);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7) const
	{
	    return fun(a1,arg,a2,a3,a4,a5,a6,a7);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8) const
	{
	    return fun(a1,arg,a2,a3,a4,a5,a6,a7,a8);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9) const
	{
	    return fun(a1,arg,a2,a3,a4,a5,a6,a7,a8,a9);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10) const
	{
	    return fun(a1,arg,a2,a3,a4,a5,a6,a7,a8,a9,a10);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11) const
	{
	    return fun(a1,arg,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12) const
	{
	    return fun(a1,arg,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13) const
	{
	    return fun(a1,arg,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14) const
	{
	    return fun(a1,arg,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14,typename Arg15>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14,const Arg15& a15) const
	{
	    return fun(a1,arg,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15);
	}
    private:
	FunctionType fun;
	Arg arg;
    };

    // bind third argument
    template<typename ReturnType,typename FunctionType,typename Arg>
    class Binder3rd
    {
    public:
	typedef ReturnType return_type;

	Binder3rd(FunctionType fun_,Arg arg_):
	    fun(fun_),
	    arg(arg_)
	{}

	template<typename Arg1,typename Arg2>
	ReturnType operator()(const Arg1& a1,const Arg2& a2) const
	{
	    return fun(a1,a2,arg);
	}
	template<typename Arg1,typename Arg2,typename Arg3>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3) const
	{
	    return fun(a1,a2,arg,a3);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4) const
	{
	    return fun(a1,a2,arg,a3,a4);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5) const
	{
	    return fun(a1,a2,arg,a3,a4,a5);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6) const
	{
	    return fun(a1,a2,arg,a3,a4,a5,a6);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7) const
	{
	    return fun(a1,a2,arg,a3,a4,a5,a6,a7);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8) const
	{
	    return fun(a1,a2,arg,a3,a4,a5,a6,a7,a8);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9) const
	{
	    return fun(a1,a2,arg,a3,a4,a5,a6,a7,a8,a9);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10) const
	{
	    return fun(a1,a2,arg,a3,a4,a5,a6,a7,a8,a9,a10);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11) const
	{
	    return fun(a1,a2,arg,a3,a4,a5,a6,a7,a8,a9,a10,a11);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12) const
	{
	    return fun(a1,a2,arg,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13) const
	{
	    return fun(a1,a2,arg,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14) const
	{
	    return fun(a1,a2,arg,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14,typename Arg15>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14,const Arg15& a15) const
	{
	    return fun(a1,a2,arg,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15);
	}
    private:
	FunctionType fun;
	Arg arg;
    };
    
    // bind fourth argument
    template<typename ReturnType,typename FunctionType,typename Arg>
    class Binder4th
    {
    public:
	typedef ReturnType return_type;

	Binder4th(FunctionType fun_,Arg arg_):
	    fun(fun_),
	    arg(arg_)
	{}

	template<typename Arg1,typename Arg2,typename Arg3>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3) const
	{
	    return fun(a1,a2,a3,arg);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4) const
	{
	    return fun(a1,a2,a3,arg,a4);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5) const
	{
	    return fun(a1,a2,a3,arg,a4,a5);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6) const
	{
	    return fun(a1,a2,a3,arg,a4,a5,a6);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7) const
	{
	    return fun(a1,a2,a3,arg,a4,a5,a6,a7);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8) const
	{
	    return fun(a1,a2,a3,arg,a4,a5,a6,a7,a8);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9) const
	{
	    return fun(a1,a2,a3,arg,a4,a5,a6,a7,a8,a9);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10) const
	{
	    return fun(a1,a2,a3,arg,a4,a5,a6,a7,a8,a9,a10);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11) const
	{
	    return fun(a1,a2,a3,arg,a4,a5,a6,a7,a8,a9,a10,a11);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12) const
	{
	    return fun(a1,a2,a3,arg,a4,a5,a6,a7,a8,a9,a10,a11,a12);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13) const
	{
	    return fun(a1,a2,a3,arg,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14) const
	{
	    return fun(a1,a2,a3,arg,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14,typename Arg15>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14,const Arg15& a15) const
	{
	    return fun(a1,a2,a3,arg,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15);
	}
    private:
	FunctionType fun;
	Arg arg;
    };

    // bind fifth argument
    template<typename ReturnType,typename FunctionType,typename Arg>
    class Binder5th
    {
    public:
	typedef ReturnType return_type;

	Binder5th(FunctionType fun_,Arg arg_):
	    fun(fun_),
	    arg(arg_)
	{}

	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4) const
	{
	    return fun(a1,a2,a3,a4,arg);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5) const
	{
	    return fun(a1,a2,a3,a4,arg,a5);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6) const
	{
	    return fun(a1,a2,a3,a4,arg,a5,a6);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7) const
	{
	    return fun(a1,a2,a3,a4,arg,a5,a6,a7);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8) const
	{
	    return fun(a1,a2,a3,a4,arg,a5,a6,a7,a8);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9) const
	{
	    return fun(a1,a2,a3,a4,arg,a5,a6,a7,a8,a9);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10) const
	{
	    return fun(a1,a2,a3,a4,arg,a5,a6,a7,a8,a9,a10);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11) const
	{
	    return fun(a1,a2,a3,a4,arg,a5,a6,a7,a8,a9,a10,a11);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12) const
	{
	    return fun(a1,a2,a3,a4,arg,a5,a6,a7,a8,a9,a10,a11,a12);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13) const
	{
	    return fun(a1,a2,a3,a4,arg,a5,a6,a7,a8,a9,a10,a11,a12,a13);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14) const
	{
	    return fun(a1,a2,a3,a4,arg,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14,typename Arg15>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14,const Arg15& a15) const
	{
	    return fun(a1,a2,a3,a4,arg,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15);
	}
    private:
	FunctionType fun;
	Arg arg;
    };

    // bind sixth argument
    template<typename ReturnType,typename FunctionType,typename Arg>
    class Binder6th
    {
    public:
	typedef ReturnType return_type;

	Binder6th(FunctionType fun_,Arg arg_):
	    fun(fun_),
	    arg(arg_)
	{}

	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5) const
	{
	    return fun(a1,a2,a3,a4,a5,arg);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6) const
	{
	    return fun(a1,a2,a3,a4,a5,arg,a6);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7) const
	{
	    return fun(a1,a2,a3,a4,a5,arg,a6,a7);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8) const
	{
	    return fun(a1,a2,a3,a4,a5,arg,a6,a7,a8);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9) const
	{
	    return fun(a1,a2,a3,a4,a5,arg,a6,a7,a8,a9);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10) const
	{
	    return fun(a1,a2,a3,a4,a5,arg,a6,a7,a8,a9,a10);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11) const
	{
	    return fun(a1,a2,a3,a4,a5,arg,a6,a7,a8,a9,a10,a11);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12) const
	{
	    return fun(a1,a2,a3,a4,a5,arg,a6,a7,a8,a9,a10,a11,a12);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13) const
	{
	    return fun(a1,a2,a3,a4,a5,arg,a6,a7,a8,a9,a10,a11,a12,a13);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14) const
	{
	    return fun(a1,a2,a3,a4,a5,arg,a6,a7,a8,a9,a10,a11,a12,a13,a14);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14,typename Arg15>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14,const Arg15& a15) const
	{
	    return fun(a1,a2,a3,a4,a5,arg,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15);
	}
    private:
	FunctionType fun;
	Arg arg;
    };

    // bind seventh argument
    template<typename ReturnType,typename FunctionType,typename Arg>
    class Binder7th
    {
    public:
	typedef ReturnType return_type;

	Binder7th(FunctionType fun_,Arg arg_):
	    fun(fun_),
	    arg(arg_)
	{}

	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,arg);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,arg,a7);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,arg,a7,a8);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,arg,a7,a8,a9);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,arg,a7,a8,a9,a10);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,arg,a7,a8,a9,a10,a11);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,arg,a7,a8,a9,a10,a11,a12);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,arg,a7,a8,a9,a10,a11,a12,a13);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,arg,a7,a8,a9,a10,a11,a12,a13,a14);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14,typename Arg15>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14,const Arg15& a15) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,arg,a7,a8,a9,a10,a11,a12,a13,a14,a15);
	}
    private:
	FunctionType fun;
	Arg arg;
    };

    // bind eighth argument
    template<typename ReturnType,typename FunctionType,typename Arg>
    class Binder8th
    {
    public:
	typedef ReturnType return_type;

	Binder8th(FunctionType fun_,Arg arg_):
	    fun(fun_),
	    arg(arg_)
	{}

	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,arg);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,arg,a8);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,arg,a8,a9);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,arg,a8,a9,a10);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,arg,a8,a9,a10,a11);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,arg,a8,a9,a10,a11,a12);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,arg,a8,a9,a10,a11,a12,a13);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,arg,a8,a9,a10,a11,a12,a13,a14);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14,typename Arg15>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14,const Arg15& a15) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,arg,a8,a9,a10,a11,a12,a13,a14,a15);
	}
    private:
	FunctionType fun;
	Arg arg;
    };

    // bind ninth argument
    template<typename ReturnType,typename FunctionType,typename Arg>
    class Binder9th
    {
    public:
	typedef ReturnType return_type;

	Binder9th(FunctionType fun_,Arg arg_):
	    fun(fun_),
	    arg(arg_)
	{}

	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,arg);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,arg,a9);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,arg,a9,a10);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,arg,a9,a10,a11);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,arg,a9,a10,a11,a12);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,arg,a9,a10,a11,a12,a13);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,arg,a9,a10,a11,a12,a13,a14);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14,typename Arg15>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14,const Arg15& a15) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,arg,a9,a10,a11,a12,a13,a14,a15);
	}
    private:
	FunctionType fun;
	Arg arg;
    };

    // bind tenth argument
    template<typename ReturnType,typename FunctionType,typename Arg>
    class Binder10th
    {
    public:
	typedef ReturnType return_type;

	Binder10th(FunctionType fun_,Arg arg_):
	    fun(fun_),
	    arg(arg_)
	{}

	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,a9,arg);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,a9,arg,a10);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,a9,arg,a10,a11);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,a9,arg,a10,a11,a12);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,a9,arg,a10,a11,a12,a13);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,a9,arg,a10,a11,a12,a13,a14);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14,typename Arg15>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14,const Arg15& a15) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,a9,arg,a10,a11,a12,a13,a14,a15);
	}
    private:
	FunctionType fun;
	Arg arg;
    };

    // bind eleventh argument
    template<typename ReturnType,typename FunctionType,typename Arg>
    class Binder11th
    {
    public:
	typedef ReturnType return_type;

	Binder11th(FunctionType fun_,Arg arg_):
	    fun(fun_),
	    arg(arg_)
	{}

	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,arg);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,arg,a11);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,arg,a11,a12);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,arg,a11,a12,a13);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,arg,a11,a12,a13,a14);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14,typename Arg15>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14,const Arg15& a15) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,arg,a11,a12,a13,a14,a15);
	}
    private:
	FunctionType fun;
	Arg arg;
    };

    // bind twelfth argument
    template<typename ReturnType,typename FunctionType,typename Arg>
    class Binder12th
    {
    public:
	typedef ReturnType return_type;

	Binder12th(FunctionType fun_,Arg arg_):
	    fun(fun_),
	    arg(arg_)
	{}

	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,arg);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,arg,a12);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,arg,a12,a13);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,arg,a12,a13,a14);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14,typename Arg15>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14,const Arg15& a15) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,arg,a12,a13,a14,a15);
	}
    private:
	FunctionType fun;
	Arg arg;
    };

    // bind thirteenth argument
    template<typename ReturnType,typename FunctionType,typename Arg>
    class Binder13th
    {
    public:
	typedef ReturnType return_type;

	Binder13th(FunctionType fun_,Arg arg_):
	    fun(fun_),
	    arg(arg_)
	{}

	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,arg);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,arg,a13);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,arg,a13,a14);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14,typename Arg15>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14,const Arg15& a15) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,arg,a13,a14,a15);
	}
    private:
	FunctionType fun;
	Arg arg;
    };

    // bind fourteenth argument
    template<typename ReturnType,typename FunctionType,typename Arg>
    class Binder14th
    {
    public:
	typedef ReturnType return_type;

	Binder14th(FunctionType fun_,Arg arg_):
	    fun(fun_),
	    arg(arg_)
	{}

	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,arg);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,arg,a14);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14,typename Arg15>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14,const Arg15& a15) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,arg,a14,a15);
	}
    private:
	FunctionType fun;
	Arg arg;
    };

    // bind fifteenth argument
    template<typename ReturnType,typename FunctionType,typename Arg>
    class Binder15th
    {
    public:
	typedef ReturnType return_type;

	Binder15th(FunctionType fun_,Arg arg_):
	    fun(fun_),
	    arg(arg_)
	{}

	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,arg);
	}
	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14,typename Arg15>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14,const Arg15& a15) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,arg,a15);
	}
    private:
	FunctionType fun;
	Arg arg;
    };

    // bind sixteenth argument
    template<typename ReturnType,typename FunctionType,typename Arg>
    class Binder16th
    {
    public:
	typedef ReturnType return_type;

	Binder16th(FunctionType fun_,Arg arg_):
	    fun(fun_),
	    arg(arg_)
	{}

	template<typename Arg1,typename Arg2,typename Arg3,typename Arg4,
		 typename Arg5,typename Arg6,typename Arg7,typename Arg8,
		 typename Arg9,typename Arg10,typename Arg11,typename Arg12,
		 typename Arg13,typename Arg14,typename Arg15>
	ReturnType operator()(const Arg1& a1,const Arg2& a2,const Arg3& a3,
			      const Arg4& a4,const Arg5& a5,const Arg6& a6,
			      const Arg7& a7,const Arg8& a8,const Arg9& a9,
			      const Arg10& a10,const Arg11& a11,const Arg12& a12,
			      const Arg13& a13,const Arg14& a14,const Arg15& a15) const
	{
	    return fun(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,arg);
	}
    private:
	FunctionType fun;
	Arg arg;
    };

    // fully-specified functors
    template<typename ReturnType>
    class Functor0
    {
    private:
	class FunctorImplBase
	{
	public:
	    virtual ReturnType call() const=0;
	    virtual std::auto_ptr<FunctorImplBase> clone() const=0;
	    virtual ~FunctorImplBase()
	    {}
	};
	template<typename FunctorType>
	class FunctorImpl:
	    public FunctorImplBase
	{
	public:
	    FunctorImpl(FunctorType fun_):
		fun(fun_)
	    {}
	    virtual std::auto_ptr<FunctorImplBase> clone() const
	    {
		return std::auto_ptr<FunctorImplBase>(new FunctorImpl<FunctorType>(*this));
	    }
	    virtual ReturnType call() const
	    {
		return fun();
	    }
	private:
	    FunctorType fun;
	};
    public:
	// make this Functor compatible with our binders
	typedef ReturnType return_type;
	// copy constructor - clone the contained Functor
	Functor0(const Functor0& old):
	    funPtr(old.funPtr->clone())
	{}
	// template constructor
	template<typename FunctorType>
	Functor0(FunctorType fun):
	    funPtr(new FunctorImpl<FunctorType>(fun))
	{}
	ReturnType operator()() const
	{
	    return funPtr->call();
	}
    private:
	std::auto_ptr<FunctorImplBase> funPtr;
    };
    template<typename ReturnType,typename Arg1>
    class Functor1
    {
    private:
	class FunctorImplBase
	{
	public:
	    virtual ReturnType call(Arg1 a1) const=0;
	    virtual std::auto_ptr<FunctorImplBase> clone() const=0;
	    virtual ~FunctorImplBase()
	    {}
	};
	template<typename FunctorType>
	class FunctorImpl:
	    public FunctorImplBase
	{
	public:
	    FunctorImpl(FunctorType fun_):
		fun(fun_)
	    {}
	    virtual std::auto_ptr<FunctorImplBase> clone() const
	    {
		return std::auto_ptr<FunctorImplBase>(new FunctorImpl<FunctorType>(*this));
	    }
	    virtual ReturnType call(Arg1 a1) const
	    {
		return fun(byRef(a1));
	    }
	private:
	    FunctorType fun;
	};
    public:
	// make this Functor compatible with our binders
	typedef ReturnType return_type;
	// copy constructor - clone the contained Functor
	Functor1(const Functor1& old):
	    funPtr(old.funPtr->clone())
	{}
	// template constructor
	template<typename FunctorType>
	Functor1(FunctorType fun):
	    funPtr(new FunctorImpl<FunctorType>(fun))
	{}
	ReturnType operator()(Arg1 a1) const
	{
	    return funPtr->call(a1);
	}
    private:
	std::auto_ptr<FunctorImplBase> funPtr;
    };
    template<typename ReturnType,typename Arg1,typename Arg2>
    class Functor2
    {
    private:
	class FunctorImplBase
	{
	public:
	    virtual ReturnType call(Arg1 a1,Arg2 a2) const=0;
	    virtual std::auto_ptr<FunctorImplBase> clone() const=0;
	    virtual ~FunctorImplBase()
	    {}
	};
	template<typename FunctorType>
	class FunctorImpl:
	    public FunctorImplBase
	{
	public:
	    FunctorImpl(FunctorType fun_):
		fun(fun_)
	    {}
	    virtual std::auto_ptr<FunctorImplBase> clone() const
	    {
		return std::auto_ptr<FunctorImplBase>(new FunctorImpl<FunctorType>(*this));
	    }
	    virtual ReturnType call(Arg1 a1,Arg2 a2) const
	    {
		return fun(byRef(a1),byRef(a2));
	    }
	private:
	    FunctorType fun;
	};
    public:
	// make this Functor compatible with our binders
	typedef ReturnType return_type;
	// copy constructor - clone the contained Functor
	Functor2(const Functor2& old):
	    funPtr(old.funPtr->clone())
	{}
	// template constructor
	template<typename FunctorType>
	Functor2(FunctorType fun):
	    funPtr(new FunctorImpl<FunctorType>(fun))
	{}
	ReturnType operator()(Arg1 a1,Arg2 a2) const
	{
	    return funPtr->call(a1,a2);
	}
    private:
	std::auto_ptr<FunctorImplBase> funPtr;
    };
    template<typename ReturnType,typename Arg1,typename Arg2,typename Arg3>
    class Functor3
    {
    private:
	class FunctorImplBase
	{
	public:
	    virtual ReturnType call(Arg1 a1,Arg2 a2,Arg3 a3) const=0;
	    virtual std::auto_ptr<FunctorImplBase> clone() const=0;
	    virtual ~FunctorImplBase()
	    {}
	};
	template<typename FunctorType>
	class FunctorImpl:
	    public FunctorImplBase
	{
	public:
	    FunctorImpl(FunctorType fun_):
		fun(fun_)
	    {}
	    virtual std::auto_ptr<FunctorImplBase> clone() const
	    {
		return std::auto_ptr<FunctorImplBase>(new FunctorImpl<FunctorType>(*this));
	    }
	    virtual ReturnType call(Arg1 a1,Arg2 a2,Arg3 a3) const
	    {
		return fun(byRef(a1),byRef(a2),byRef(a3));
	    }
	private:
	    FunctorType fun;
	};
    public:
	// make this Functor compatible with our binders
	typedef ReturnType return_type;
	// copy constructor - clone the contained Functor
	Functor3(const Functor3& old):
	    funPtr(old.funPtr->clone())
	{}
	// template constructor
	template<typename FunctorType>
	Functor3(FunctorType fun):
	    funPtr(new FunctorImpl<FunctorType>(fun))
	{}
	ReturnType operator()(Arg1 a1,Arg2 a2,Arg3 a3) const
	{
	    return funPtr->call(a1,a2,a3);
	}
    private:
	std::auto_ptr<FunctorImplBase> funPtr;
    };
    template<typename ReturnType,typename Arg1,typename Arg2,typename Arg3,typename Arg4>
    class Functor4
    {
    private:
	class FunctorImplBase
	{
	public:
	    virtual ReturnType call(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4) const=0;
	    virtual std::auto_ptr<FunctorImplBase> clone() const=0;
	    virtual ~FunctorImplBase()
	    {}
	};
	template<typename FunctorType>
	class FunctorImpl:
	    public FunctorImplBase
	{
	public:
	    FunctorImpl(FunctorType fun_):
		fun(fun_)
	    {}
	    virtual std::auto_ptr<FunctorImplBase> clone() const
	    {
		return std::auto_ptr<FunctorImplBase>(new FunctorImpl<FunctorType>(*this));
	    }
	    virtual ReturnType call(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4) const
	    {
		return fun(byRef(a1),byRef(a2),byRef(a3),byRef(a4));
	    }
	private:
	    FunctorType fun;
	};
    public:
	// make this Functor compatible with our binders
	typedef ReturnType return_type;
	// copy constructor - clone the contained Functor
	Functor4(const Functor4& old):
	    funPtr(old.funPtr->clone())
	{}
	// template constructor
	template<typename FunctorType>
	Functor4(FunctorType fun):
	    funPtr(new FunctorImpl<FunctorType>(fun))
	{}
	ReturnType operator()(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4) const
	{
	    return funPtr->call(a1,a2,a3,a4);
	}
    private:
	std::auto_ptr<FunctorImplBase> funPtr;
    };
    template<typename ReturnType,typename Arg1,typename Arg2,typename Arg3,typename Arg4,
	     typename Arg5>
    class Functor5
    {
    private:
	class FunctorImplBase
	{
	public:
	    virtual ReturnType call(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4,Arg5 a5) const=0;
	    virtual std::auto_ptr<FunctorImplBase> clone() const=0;
	    virtual ~FunctorImplBase()
	    {}
	};
	template<typename FunctorType>
	class FunctorImpl:
	    public FunctorImplBase
	{
	public:
	    FunctorImpl(FunctorType fun_):
		fun(fun_)
	    {}
	    virtual std::auto_ptr<FunctorImplBase> clone() const
	    {
		return std::auto_ptr<FunctorImplBase>(new FunctorImpl<FunctorType>(*this));
	    }
	    virtual ReturnType call(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4,Arg5 a5) const
	    {
		return fun(byRef(a1),byRef(a2),byRef(a3),byRef(a4),byRef(a5));
	    }
	private:
	    FunctorType fun;
	};
    public:
	// make this Functor compatible with our binders
	typedef ReturnType return_type;
	// copy constructor - clone the contained Functor
	Functor5(const Functor5& old):
	    funPtr(old.funPtr->clone())
	{}
	// template constructor
	template<typename FunctorType>
	Functor5(FunctorType fun):
	    funPtr(new FunctorImpl<FunctorType>(fun))
	{}
	ReturnType operator()(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4,Arg5 a5) const
	{
	    return funPtr->call(a1,a2,a3,a4,a5);
	}
    private:
	std::auto_ptr<FunctorImplBase> funPtr;
    };
    template<typename ReturnType,typename Arg1,typename Arg2,typename Arg3,typename Arg4,
	     typename Arg5,typename Arg6>
    class Functor6
    {
    private:
	class FunctorImplBase
	{
	public:
	    virtual ReturnType call(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4,Arg5 a5,Arg6 a6) const=0;
	    virtual std::auto_ptr<FunctorImplBase> clone() const=0;
	    virtual ~FunctorImplBase()
	    {}
	};
	template<typename FunctorType>
	class FunctorImpl:
	    public FunctorImplBase
	{
	public:
	    FunctorImpl(FunctorType fun_):
		fun(fun_)
	    {}
	    virtual std::auto_ptr<FunctorImplBase> clone() const
	    {
		return std::auto_ptr<FunctorImplBase>(new FunctorImpl<FunctorType>(*this));
	    }
	    virtual ReturnType call(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4,Arg5 a5,Arg6 a6) const
	    {
		return fun(byRef(a1),byRef(a2),byRef(a3),byRef(a4),byRef(a5),byRef(a6));
	    }
	private:
	    FunctorType fun;
	};
    public:
	// make this Functor compatible with our binders
	typedef ReturnType return_type;
	// copy constructor - clone the contained Functor
	Functor6(const Functor6& old):
	    funPtr(old.funPtr->clone())
	{}
	// template constructor
	template<typename FunctorType>
	Functor6(FunctorType fun):
	    funPtr(new FunctorImpl<FunctorType>(fun))
	{}
	ReturnType operator()(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4,Arg5 a5,Arg6 a6) const
	{
	    return funPtr->call(a1,a2,a3,a4,a5,a6);
	}
    private:
	std::auto_ptr<FunctorImplBase> funPtr;
    };
    template<typename ReturnType,typename Arg1,typename Arg2,typename Arg3,typename Arg4,
	     typename Arg5,typename Arg6,typename Arg7>
    class Functor7
    {
    private:
	class FunctorImplBase
	{
	public:
	    virtual ReturnType call(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4,Arg5 a5,Arg6 a6,Arg7 a7) const=0;
	    virtual std::auto_ptr<FunctorImplBase> clone() const=0;
	    virtual ~FunctorImplBase()
	    {}
	};
	template<typename FunctorType>
	class FunctorImpl:
	    public FunctorImplBase
	{
	public:
	    FunctorImpl(FunctorType fun_):
		fun(fun_)
	    {}
	    virtual std::auto_ptr<FunctorImplBase> clone() const
	    {
		return std::auto_ptr<FunctorImplBase>(new FunctorImpl<FunctorType>(*this));
	    }
	    virtual ReturnType call(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4,Arg5 a5,Arg6 a6,Arg7 a7) const
	    {
		return fun(byRef(a1),byRef(a2),byRef(a3),byRef(a4),byRef(a5),byRef(a6),byRef(a7));
	    }
	private:
	    FunctorType fun;
	};
    public:
	// make this Functor compatible with our binders
	typedef ReturnType return_type;
	// copy constructor - clone the contained Functor
	Functor7(const Functor7& old):
	    funPtr(old.funPtr->clone())
	{}
	// template constructor
	template<typename FunctorType>
	Functor7(FunctorType fun):
	    funPtr(new FunctorImpl<FunctorType>(fun))
	{}
	ReturnType operator()(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4,Arg5 a5,Arg6 a6,Arg7 a7) const
	{
	    return funPtr->call(a1,a2,a3,a4,a5,a6,a7);
	}
    private:
	std::auto_ptr<FunctorImplBase> funPtr;
    };
    template<typename ReturnType,typename Arg1,typename Arg2,typename Arg3,typename Arg4,
	     typename Arg5,typename Arg6,typename Arg7,typename Arg8>
    class Functor8
    {
    private:
	class FunctorImplBase
	{
	public:
	    virtual ReturnType call(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4,Arg5 a5,Arg6 a6,Arg7 a7,Arg8 a8) const=0;
	    virtual std::auto_ptr<FunctorImplBase> clone() const=0;
	    virtual ~FunctorImplBase()
	    {}
	};
	template<typename FunctorType>
	class FunctorImpl:
	    public FunctorImplBase
	{
	public:
	    FunctorImpl(FunctorType fun_):
		fun(fun_)
	    {}
	    virtual std::auto_ptr<FunctorImplBase> clone() const
	    {
		return std::auto_ptr<FunctorImplBase>(new FunctorImpl<FunctorType>(*this));
	    }
	    virtual ReturnType call(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4,Arg5 a5,Arg6 a6,Arg7 a7,Arg8 a8) const
	    {
		return fun(byRef(a1),byRef(a2),byRef(a3),byRef(a4),byRef(a5),byRef(a6),byRef(a7),byRef(a8));
	    }
	private:
	    FunctorType fun;
	};
    public:
	// make this Functor compatible with our binders
	typedef ReturnType return_type;
	// copy constructor - clone the contained Functor
	Functor8(const Functor8& old):
	    funPtr(old.funPtr->clone())
	{}
	// template constructor
	template<typename FunctorType>
	Functor8(FunctorType fun):
	    funPtr(new FunctorImpl<FunctorType>(fun))
	{}
	ReturnType operator()(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4,Arg5 a5,Arg6 a6,Arg7 a7,Arg8 a8) const
	{
	    return funPtr->call(a1,a2,a3,a4,a5,a6,a7,a8);
	}
    private:
	std::auto_ptr<FunctorImplBase> funPtr;
    };
    template<typename ReturnType,typename Arg1,typename Arg2,typename Arg3,typename Arg4,
	     typename Arg5,typename Arg6,typename Arg7,typename Arg8,
	     typename Arg9>
    class Functor9
    {
    private:
	class FunctorImplBase
	{
	public:
	    virtual ReturnType call(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4,Arg5 a5,Arg6 a6,Arg7 a7,Arg8 a8,
				    Arg9 a9) const=0;
	    virtual std::auto_ptr<FunctorImplBase> clone() const=0;
	    virtual ~FunctorImplBase()
	    {}
	};
	template<typename FunctorType>
	class FunctorImpl:
	    public FunctorImplBase
	{
	public:
	    FunctorImpl(FunctorType fun_):
		fun(fun_)
	    {}
	    virtual std::auto_ptr<FunctorImplBase> clone() const
	    {
		return std::auto_ptr<FunctorImplBase>(new FunctorImpl<FunctorType>(*this));
	    }
	    virtual ReturnType call(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4,Arg5 a5,Arg6 a6,Arg7 a7,Arg8 a8,
				    Arg9 a9) const
	    {
		return fun(byRef(a1),byRef(a2),byRef(a3),byRef(a4),byRef(a5),byRef(a6),byRef(a7),byRef(a8),
			   byRef(a9));
	    }
	private:
	    FunctorType fun;
	};
    public:
	// make this Functor compatible with our binders
	typedef ReturnType return_type;
	// copy constructor - clone the contained Functor
	Functor9(const Functor9& old):
	    funPtr(old.funPtr->clone())
	{}
	// template constructor
	template<typename FunctorType>
	Functor9(FunctorType fun):
	    funPtr(new FunctorImpl<FunctorType>(fun))
	{}
	ReturnType operator()(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4,Arg5 a5,Arg6 a6,Arg7 a7,Arg8 a8,
			      Arg9 a9) const
	{
	    return funPtr->call(a1,a2,a3,a4,a5,a6,a7,a8,a9);
	}
    private:
	std::auto_ptr<FunctorImplBase> funPtr;
    };
    template<typename ReturnType,typename Arg1,typename Arg2,typename Arg3,typename Arg4,
	     typename Arg5,typename Arg6,typename Arg7,typename Arg8,
	     typename Arg9,typename Arg10>
    class Functor10
    {
    private:
	class FunctorImplBase
	{
	public:
	    virtual ReturnType call(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4,Arg5 a5,Arg6 a6,Arg7 a7,Arg8 a8,
				    Arg9 a9,Arg10 a10) const=0;
	    virtual std::auto_ptr<FunctorImplBase> clone() const=0;
	    virtual ~FunctorImplBase()
	    {}
	};
	template<typename FunctorType>
	class FunctorImpl:
	    public FunctorImplBase
	{
	public:
	    FunctorImpl(FunctorType fun_):
		fun(fun_)
	    {}
	    virtual std::auto_ptr<FunctorImplBase> clone() const
	    {
		return std::auto_ptr<FunctorImplBase>(new FunctorImpl<FunctorType>(*this));
	    }
	    virtual ReturnType call(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4,Arg5 a5,Arg6 a6,Arg7 a7,Arg8 a8,
				    Arg9 a9,Arg10 a10) const
	    {
		return fun(byRef(a1),byRef(a2),byRef(a3),byRef(a4),byRef(a5),byRef(a6),byRef(a7),byRef(a8),
			   byRef(a9),byRef(a10));
	    }
	private:
	    FunctorType fun;
	};
    public:
	// make this Functor compatible with our binders
	typedef ReturnType return_type;
	// copy constructor - clone the contained Functor
	Functor10(const Functor10& old):
	    funPtr(old.funPtr->clone())
	{}
	// template constructor
	template<typename FunctorType>
	Functor10(FunctorType fun):
	    funPtr(new FunctorImpl<FunctorType>(fun))
	{}
	ReturnType operator()(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4,Arg5 a5,Arg6 a6,Arg7 a7,Arg8 a8,
			      Arg9 a9,Arg10 a10) const
	{
	    return funPtr->call(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10);
	}
    private:
	std::auto_ptr<FunctorImplBase> funPtr;
    };
    template<typename ReturnType,typename Arg1,typename Arg2,typename Arg3,typename Arg4,
	     typename Arg5,typename Arg6,typename Arg7,typename Arg8,
	     typename Arg9,typename Arg10,typename Arg11>
    class Functor11
    {
    private:
	class FunctorImplBase
	{
	public:
	    virtual ReturnType call(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4,Arg5 a5,Arg6 a6,Arg7 a7,Arg8 a8,
				    Arg9 a9,Arg10 a10,Arg11 a11) const=0;
	    virtual std::auto_ptr<FunctorImplBase> clone() const=0;
	    virtual ~FunctorImplBase()
	    {}
	};
	template<typename FunctorType>
	class FunctorImpl:
	    public FunctorImplBase
	{
	public:
	    FunctorImpl(FunctorType fun_):
		fun(fun_)
	    {}
	    virtual std::auto_ptr<FunctorImplBase> clone() const
	    {
		return std::auto_ptr<FunctorImplBase>(new FunctorImpl<FunctorType>(*this));
	    }
	    virtual ReturnType call(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4,Arg5 a5,Arg6 a6,Arg7 a7,Arg8 a8,
				    Arg9 a9,Arg10 a10,Arg11 a11) const
	    {
		return fun(byRef(a1),byRef(a2),byRef(a3),byRef(a4),byRef(a5),byRef(a6),byRef(a7),byRef(a8),
			   byRef(a9),byRef(a10),byRef(a11));
	    }
	private:
	    FunctorType fun;
	};
    public:
	// make this Functor compatible with our binders
	typedef ReturnType return_type;
	// copy constructor - clone the contained Functor
	Functor11(const Functor11& old):
	    funPtr(old.funPtr->clone())
	{}
	// template constructor
	template<typename FunctorType>
	Functor11(FunctorType fun):
	    funPtr(new FunctorImpl<FunctorType>(fun))
	{}
	ReturnType operator()(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4,Arg5 a5,Arg6 a6,Arg7 a7,Arg8 a8,
			      Arg9 a9,Arg10 a10,Arg11 a11) const
	{
	    return funPtr->call(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11);
	}
    private:
	std::auto_ptr<FunctorImplBase> funPtr;
    };
    template<typename ReturnType,typename Arg1,typename Arg2,typename Arg3,typename Arg4,
	     typename Arg5,typename Arg6,typename Arg7,typename Arg8,
	     typename Arg9,typename Arg10,typename Arg11,typename Arg12>
    class Functor12
    {
    private:
	class FunctorImplBase
	{
	public:
	    virtual ReturnType call(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4,Arg5 a5,Arg6 a6,Arg7 a7,Arg8 a8,
				    Arg9 a9,Arg10 a10,Arg11 a11,Arg12 a12) const=0;
	    virtual std::auto_ptr<FunctorImplBase> clone() const=0;
	    virtual ~FunctorImplBase()
	    {}
	};
	template<typename FunctorType>
	class FunctorImpl:
	    public FunctorImplBase
	{
	public:
	    FunctorImpl(FunctorType fun_):
		fun(fun_)
	    {}
	    virtual std::auto_ptr<FunctorImplBase> clone() const
	    {
		return std::auto_ptr<FunctorImplBase>(new FunctorImpl<FunctorType>(*this));
	    }
	    virtual ReturnType call(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4,Arg5 a5,Arg6 a6,Arg7 a7,Arg8 a8,
				    Arg9 a9,Arg10 a10,Arg11 a11,Arg12 a12) const
	    {
		return fun(byRef(a1),byRef(a2),byRef(a3),byRef(a4),byRef(a5),byRef(a6),byRef(a7),byRef(a8),
			   byRef(a9),byRef(a10),byRef(a11),byRef(a12));
	    }
	private:
	    FunctorType fun;
	};
    public:
	// make this Functor compatible with our binders
	typedef ReturnType return_type;
	// copy constructor - clone the contained Functor
	Functor12(const Functor12& old):
	    funPtr(old.funPtr->clone())
	{}
	// template constructor
	template<typename FunctorType>
	Functor12(FunctorType fun):
	    funPtr(new FunctorImpl<FunctorType>(fun))
	{}
	ReturnType operator()(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4,Arg5 a5,Arg6 a6,Arg7 a7,Arg8 a8,
			      Arg9 a9,Arg10 a10,Arg11 a11,Arg12 a12) const
	{
	    return funPtr->call(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12);
	}
    private:
	std::auto_ptr<FunctorImplBase> funPtr;
    };
    template<typename ReturnType,typename Arg1,typename Arg2,typename Arg3,typename Arg4,
	     typename Arg5,typename Arg6,typename Arg7,typename Arg8,
	     typename Arg9,typename Arg10,typename Arg11,typename Arg12,
	     typename Arg13>
    class Functor13
    {
    private:
	class FunctorImplBase
	{
	public:
	    virtual ReturnType call(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4,Arg5 a5,Arg6 a6,Arg7 a7,Arg8 a8,
				    Arg9 a9,Arg10 a10,Arg11 a11,Arg12 a12,Arg13 a13) const=0;
	    virtual std::auto_ptr<FunctorImplBase> clone() const=0;
	    virtual ~FunctorImplBase()
	    {}
	};
	template<typename FunctorType>
	class FunctorImpl:
	    public FunctorImplBase
	{
	public:
	    FunctorImpl(FunctorType fun_):
		fun(fun_)
	    {}
	    virtual std::auto_ptr<FunctorImplBase> clone() const
	    {
		return std::auto_ptr<FunctorImplBase>(new FunctorImpl<FunctorType>(*this));
	    }
	    virtual ReturnType call(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4,Arg5 a5,Arg6 a6,Arg7 a7,Arg8 a8,
				    Arg9 a9,Arg10 a10,Arg11 a11,Arg12 a12,Arg13 a13) const
	    {
		return fun(byRef(a1),byRef(a2),byRef(a3),byRef(a4),byRef(a5),byRef(a6),byRef(a7),byRef(a8),
			   byRef(a9),byRef(a10),byRef(a11),byRef(a12),byRef(a13));
	    }
	private:
	    FunctorType fun;
	};
    public:
	// make this Functor compatible with our binders
	typedef ReturnType return_type;
	// copy constructor - clone the contained Functor
	Functor13(const Functor13& old):
	    funPtr(old.funPtr->clone())
	{}
	// template constructor
	template<typename FunctorType>
	Functor13(FunctorType fun):
	    funPtr(new FunctorImpl<FunctorType>(fun))
	{}
	ReturnType operator()(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4,Arg5 a5,Arg6 a6,Arg7 a7,Arg8 a8,
			      Arg9 a9,Arg10 a10,Arg11 a11,Arg12 a12,Arg13 a13) const
	{
	    return funPtr->call(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13);
	}
    private:
	std::auto_ptr<FunctorImplBase> funPtr;
    };
    template<typename ReturnType,typename Arg1,typename Arg2,typename Arg3,typename Arg4,
	     typename Arg5,typename Arg6,typename Arg7,typename Arg8,
	     typename Arg9,typename Arg10,typename Arg11,typename Arg12,
	     typename Arg13,typename Arg14>
    class Functor14
    {
    private:
	class FunctorImplBase
	{
	public:
	    virtual ReturnType call(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4,Arg5 a5,Arg6 a6,Arg7 a7,Arg8 a8,
				    Arg9 a9,Arg10 a10,Arg11 a11,Arg12 a12,Arg13 a13,Arg14 a14) const=0;
	    virtual std::auto_ptr<FunctorImplBase> clone() const=0;
	    virtual ~FunctorImplBase()
	    {}
	};
	template<typename FunctorType>
	class FunctorImpl:
	    public FunctorImplBase
	{
	public:
	    FunctorImpl(FunctorType fun_):
		fun(fun_)
	    {}
	    virtual std::auto_ptr<FunctorImplBase> clone() const
	    {
		return std::auto_ptr<FunctorImplBase>(new FunctorImpl<FunctorType>(*this));
	    }
	    virtual ReturnType call(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4,Arg5 a5,Arg6 a6,Arg7 a7,Arg8 a8,
				    Arg9 a9,Arg10 a10,Arg11 a11,Arg12 a12,Arg13 a13,Arg14 a14) const
	    {
		return fun(byRef(a1),byRef(a2),byRef(a3),byRef(a4),byRef(a5),byRef(a6),byRef(a7),byRef(a8),
			   byRef(a9),byRef(a10),byRef(a11),byRef(a12),byRef(a13),byRef(a14));
	    }
	private:
	    FunctorType fun;
	};
    public:
	// make this Functor compatible with our binders
	typedef ReturnType return_type;
	// copy constructor - clone the contained Functor
	Functor14(const Functor14& old):
	    funPtr(old.funPtr->clone())
	{}
	// template constructor
	template<typename FunctorType>
	Functor14(FunctorType fun):
	    funPtr(new FunctorImpl<FunctorType>(fun))
	{}
	ReturnType operator()(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4,Arg5 a5,Arg6 a6,Arg7 a7,Arg8 a8,
			      Arg9 a9,Arg10 a10,Arg11 a11,Arg12 a12,Arg13 a13,Arg14 a14) const
	{
	    return funPtr->call(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14);
	}
    private:
	std::auto_ptr<FunctorImplBase> funPtr;
    };
    template<typename ReturnType,typename Arg1,typename Arg2,typename Arg3,typename Arg4,
	     typename Arg5,typename Arg6,typename Arg7,typename Arg8,
	     typename Arg9,typename Arg10,typename Arg11,typename Arg12,
	     typename Arg13,typename Arg14,typename Arg15>
    class Functor15
    {
    private:
	class FunctorImplBase
	{
	public:
	    virtual ReturnType call(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4,Arg5 a5,Arg6 a6,Arg7 a7,Arg8 a8,
				    Arg9 a9,Arg10 a10,Arg11 a11,Arg12 a12,Arg13 a13,Arg14 a14,Arg15 a15) const=0;
	    virtual std::auto_ptr<FunctorImplBase> clone() const=0;
	    virtual ~FunctorImplBase()
	    {}
	};
	template<typename FunctorType>
	class FunctorImpl:
	    public FunctorImplBase
	{
	public:
	    FunctorImpl(FunctorType fun_):
		fun(fun_)
	    {}
	    virtual std::auto_ptr<FunctorImplBase> clone() const
	    {
		return std::auto_ptr<FunctorImplBase>(new FunctorImpl<FunctorType>(*this));
	    }
	    virtual ReturnType call(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4,Arg5 a5,Arg6 a6,Arg7 a7,Arg8 a8,
				    Arg9 a9,Arg10 a10,Arg11 a11,Arg12 a12,Arg13 a13,Arg14 a14,Arg15 a15) const
	    {
		return fun(byRef(a1),byRef(a2),byRef(a3),byRef(a4),byRef(a5),byRef(a6),byRef(a7),byRef(a8),
			   byRef(a9),byRef(a10),byRef(a11),byRef(a12),byRef(a13),byRef(a14),byRef(a15));
	    }
	private:
	    FunctorType fun;
	};
    public:
	// make this Functor compatible with our binders
	typedef ReturnType return_type;
	// copy constructor - clone the contained Functor
	Functor15(const Functor15& old):
	    funPtr(old.funPtr->clone())
	{}
	// template constructor
	template<typename FunctorType>
	Functor15(FunctorType fun):
	    funPtr(new FunctorImpl<FunctorType>(fun))
	{}
	ReturnType operator()(Arg1 a1,Arg2 a2,Arg3 a3,Arg4 a4,Arg5 a5,Arg6 a6,Arg7 a7,Arg8 a8,
			      Arg9 a9,Arg10 a10,Arg11 a11,Arg12 a12,Arg13 a13,Arg14 a14,Arg15 a15) const
	{
	    return funPtr->call(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15);
	}
    private:
	std::auto_ptr<FunctorImplBase> funPtr;
    };
}

#endif
