#ifndef FUNCTIONAL_HELPERS_HH
#define FUNCTIONAL_HELPERS_HH

// functional programming helper functions
// Copyright 2001 Anthony Williams

#include "functional_classes.hh"
#include "functional_refholder.hh"

namespace functional
{
    // helper functions - overloaded function "functor" will try and adapt anything
    template<typename FunctorType>
    FunctorAdaptor<typename FunctorType::return_type,
		   FunctorType>
    functor(FunctorType fun)
    {
	return fun;
    }
    template<typename ReturnType>
    FunctorAdaptor<ReturnType,
		   ReturnType (*)()>
    functor(ReturnType (*fun)())
    {
	return fun;
    }
    template<typename ReturnType,
	     typename Arg1>
    FunctorAdaptor<ReturnType,
		   ReturnType (*)(Arg1)>
    functor(ReturnType (*fun)(Arg1))
    {
	return fun;
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2>
    FunctorAdaptor<ReturnType,
		   ReturnType (*)(Arg1,Arg2)>
    functor(ReturnType (*fun)(Arg1,Arg2))
    {
	return fun;
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3>
    FunctorAdaptor<ReturnType,
		   ReturnType (*)(Arg1,Arg2,Arg3)>
    functor(ReturnType (*fun)(Arg1,Arg2,Arg3))
    {
	return fun;
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4>
    FunctorAdaptor<ReturnType,
		   ReturnType (*)(Arg1,Arg2,Arg3,Arg4)>
    functor(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4))
    {
	return fun;
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5>
    FunctorAdaptor<ReturnType,
		   ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5)>
    functor(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5))
    {
	return fun;
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6>
    FunctorAdaptor<ReturnType,
		   ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6)>
    functor(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6))
    {
	return fun;
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7>
    FunctorAdaptor<ReturnType,
		   ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7)>
    functor(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7))
    {
	return fun;
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8>
    FunctorAdaptor<ReturnType,
		   ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8)>
    functor(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8))
    {
	return fun;
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9>
    FunctorAdaptor<ReturnType,
		   ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9)>
    functor(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9))
    {
	return fun;
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10>
    FunctorAdaptor<ReturnType,
		   ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10)>
    functor(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10))
    {
	return fun;
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11>
    FunctorAdaptor<ReturnType,
		   ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
				  Arg11)>
    functor(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11))
    {
	return fun;
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12>
    FunctorAdaptor<ReturnType,
		   ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
				  Arg11,Arg12)>
    functor(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12))
    {
	return fun;
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13>
    FunctorAdaptor<ReturnType,
		   ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
				  Arg11,Arg12,Arg13)>
    functor(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13))
    {
	return fun;
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14>
    FunctorAdaptor<ReturnType,
		   ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
				  Arg11,Arg12,Arg13,Arg14)>
    functor(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13,Arg14))
    {
	return fun;
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15>
    FunctorAdaptor<ReturnType,
		   ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
				  Arg11,Arg12,Arg13,Arg14,Arg15)>
    functor(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13,Arg14,Arg15))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)()>
    functor(ReturnType (ObjectType::*fun)())
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1)>
    functor(ReturnType (ObjectType::*fun)(Arg1))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2)>
    functor(ReturnType (ObjectType::*fun)(Arg1,Arg2))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3)>
    functor(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4)>
    functor(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5)>
    functor(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6)>
    functor(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7)>
    functor(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8)>
    functor(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9)>
    functor(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10)>
    functor(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								Arg11)>
    functor(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								Arg11,Arg12)>
    functor(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								Arg11,Arg12,Arg13)>
    functor(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								Arg11,Arg12,Arg13,Arg14)>
    functor(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								Arg11,Arg12,Arg13,Arg14,Arg15)>
    functor(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14,Arg15))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)() const>
    functor(ReturnType (ObjectType::*fun)() const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1) const>
    functor(ReturnType (ObjectType::*fun)(Arg1) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2) const>
    functor(ReturnType (ObjectType::*fun)(Arg1,Arg2) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3) const>
    functor(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4) const>
    functor(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5) const>
    functor(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6) const>
    functor(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7) const>
    functor(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8) const>
    functor(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9) const>
    functor(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10) const>
    functor(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								Arg11) const>
    functor(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								Arg11,Arg12) const>
    functor(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								Arg11,Arg12,Arg13) const>
    functor(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								Arg11,Arg12,Arg13,Arg14) const>
    functor(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								Arg11,Arg12,Arg13,Arg14,Arg15) const>
    functor(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14,Arg15) const)
    {
	return fun;
    }

    // helper functions that specify explicitly what we're adapting
    template<typename FunctorType>
    FunctorAdaptor<typename FunctorType::return_type,
		   FunctorType>
    genericFunctor(FunctorType fun)
    {
	return fun;
    }
    template<typename ReturnType>
    FunctorAdaptor<ReturnType,
		   ReturnType (*)()>
    pointerToFunction(ReturnType (*fun)())
    {
	return fun;
    }
    template<typename ReturnType,
	     typename Arg1>
    FunctorAdaptor<ReturnType,
		   ReturnType (*)(Arg1)>
    pointerToFunction(ReturnType (*fun)(Arg1))
    {
	return fun;
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2>
    FunctorAdaptor<ReturnType,
		   ReturnType (*)(Arg1,Arg2)>
    pointerToFunction(ReturnType (*fun)(Arg1,Arg2))
    {
	return fun;
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3>
    FunctorAdaptor<ReturnType,
		   ReturnType (*)(Arg1,Arg2,Arg3)>
    pointerToFunction(ReturnType (*fun)(Arg1,Arg2,Arg3))
    {
	return fun;
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4>
    FunctorAdaptor<ReturnType,
		   ReturnType (*)(Arg1,Arg2,Arg3,Arg4)>
    pointerToFunction(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4))
    {
	return fun;
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5>
    FunctorAdaptor<ReturnType,
		   ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5)>
    pointerToFunction(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5))
    {
	return fun;
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6>
    FunctorAdaptor<ReturnType,
		   ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6)>
    pointerToFunction(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6))
    {
	return fun;
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7>
    FunctorAdaptor<ReturnType,
		   ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7)>
    pointerToFunction(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7))
    {
	return fun;
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8>
    FunctorAdaptor<ReturnType,
		   ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8)>
    pointerToFunction(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8))
    {
	return fun;
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9>
    FunctorAdaptor<ReturnType,
		   ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9)>
    pointerToFunction(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9))
    {
	return fun;
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10>
    FunctorAdaptor<ReturnType,
		   ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10)>
    pointerToFunction(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10))
    {
	return fun;
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11>
    FunctorAdaptor<ReturnType,
		   ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
				  Arg11)>
    pointerToFunction(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					Arg11))
    {
	return fun;
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12>
    FunctorAdaptor<ReturnType,
		   ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
				  Arg11,Arg12)>
    pointerToFunction(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					Arg11,Arg12))
    {
	return fun;
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13>
    FunctorAdaptor<ReturnType,
		   ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
				  Arg11,Arg12,Arg13)>
    pointerToFunction(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					Arg11,Arg12,Arg13))
    {
	return fun;
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14>
    FunctorAdaptor<ReturnType,
		   ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
				  Arg11,Arg12,Arg13,Arg14)>
    pointerToFunction(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					Arg11,Arg12,Arg13,Arg14))
    {
	return fun;
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15>
    FunctorAdaptor<ReturnType,
		   ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
				  Arg11,Arg12,Arg13,Arg14,Arg15)>
    pointerToFunction(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					Arg11,Arg12,Arg13,Arg14,Arg15))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)()>
    memberFunctionObjectByPtr(ReturnType (ObjectType::*fun)())
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1)>
    memberFunctionObjectByPtr(ReturnType (ObjectType::*fun)(Arg1))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2)>
    memberFunctionObjectByPtr(ReturnType (ObjectType::*fun)(Arg1,Arg2))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3)>
    memberFunctionObjectByPtr(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4)>
    memberFunctionObjectByPtr(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5)>
    memberFunctionObjectByPtr(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6)>
    memberFunctionObjectByPtr(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7)>
    memberFunctionObjectByPtr(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8)>
    memberFunctionObjectByPtr(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9)>
    memberFunctionObjectByPtr(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10)>
    memberFunctionObjectByPtr(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								Arg11)>
    memberFunctionObjectByPtr(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
							    Arg11))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								Arg11,Arg12)>
    memberFunctionObjectByPtr(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
							    Arg11,Arg12))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								Arg11,Arg12,Arg13)>
    memberFunctionObjectByPtr(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
							    Arg11,Arg12,Arg13))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								Arg11,Arg12,Arg13,Arg14)>
    memberFunctionObjectByPtr(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
							    Arg11,Arg12,Arg13,Arg14))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								Arg11,Arg12,Arg13,Arg14,Arg15)>
    memberFunctionObjectByPtr(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
							    Arg11,Arg12,Arg13,Arg14,Arg15))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)() const>
    constMemberFunctionObjectByPtr(ReturnType (ObjectType::*fun)() const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1) const>
    constMemberFunctionObjectByPtr(ReturnType (ObjectType::*fun)(Arg1) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2) const>
    constMemberFunctionObjectByPtr(ReturnType (ObjectType::*fun)(Arg1,Arg2) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3) const>
    constMemberFunctionObjectByPtr(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4) const>
    constMemberFunctionObjectByPtr(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5) const>
    constMemberFunctionObjectByPtr(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6) const>
    constMemberFunctionObjectByPtr(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7) const>
    constMemberFunctionObjectByPtr(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8) const>
    constMemberFunctionObjectByPtr(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9) const>
    constMemberFunctionObjectByPtr(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10) const>
    constMemberFunctionObjectByPtr(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								Arg11) const>
    constMemberFunctionObjectByPtr(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								 Arg11) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								Arg11,Arg12) const>
    constMemberFunctionObjectByPtr(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								 Arg11,Arg12) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								Arg11,Arg12,Arg13) const>
    constMemberFunctionObjectByPtr(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								 Arg11,Arg12,Arg13) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								Arg11,Arg12,Arg13,Arg14) const>
    constMemberFunctionObjectByPtr(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								 Arg11,Arg12,Arg13,Arg14) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15>
    MemberFunctionAdaptorObjectByPtr<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								Arg11,Arg12,Arg13,Arg14,Arg15) const>
    constMemberFunctionObjectByPtr(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								 Arg11,Arg12,Arg13,Arg14,Arg15) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType>
    MemberFunctionAdaptorObjectByRef<ReturnType,
				     ReturnType (ObjectType::*)()>
    memberFunctionObjectByRef(ReturnType (ObjectType::*fun)())
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1>
    MemberFunctionAdaptorObjectByRef<ReturnType,
				     ReturnType (ObjectType::*)(Arg1)>
    memberFunctionObjectByRef(ReturnType (ObjectType::*fun)(Arg1))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2>
    MemberFunctionAdaptorObjectByRef<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2)>
    memberFunctionObjectByRef(ReturnType (ObjectType::*fun)(Arg1,Arg2))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3>
    MemberFunctionAdaptorObjectByRef<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3)>
    memberFunctionObjectByRef(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4>
    MemberFunctionAdaptorObjectByRef<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4)>
    memberFunctionObjectByRef(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5>
    MemberFunctionAdaptorObjectByRef<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5)>
    memberFunctionObjectByRef(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6>
    MemberFunctionAdaptorObjectByRef<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6)>
    memberFunctionObjectByRef(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7>
    MemberFunctionAdaptorObjectByRef<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7)>
    memberFunctionObjectByRef(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8>
    MemberFunctionAdaptorObjectByRef<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8)>
    memberFunctionObjectByRef(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9>
    MemberFunctionAdaptorObjectByRef<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9)>
    memberFunctionObjectByRef(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10>
    MemberFunctionAdaptorObjectByRef<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10)>
    memberFunctionObjectByRef(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11>
    MemberFunctionAdaptorObjectByRef<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								Arg11)>
    memberFunctionObjectByRef(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
							    Arg11))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12>
    MemberFunctionAdaptorObjectByRef<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								Arg11,Arg12)>
    memberFunctionObjectByRef(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
							    Arg11,Arg12))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13>
    MemberFunctionAdaptorObjectByRef<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								Arg11,Arg12,Arg13)>
    memberFunctionObjectByRef(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
							    Arg11,Arg12,Arg13))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14>
    MemberFunctionAdaptorObjectByRef<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								Arg11,Arg12,Arg13,Arg14)>
    memberFunctionObjectByRef(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
							    Arg11,Arg12,Arg13,Arg14))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15>
    MemberFunctionAdaptorObjectByRef<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								Arg11,Arg12,Arg13,Arg14,Arg15)>
    memberFunctionObjectByRef(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
							    Arg11,Arg12,Arg13,Arg14,Arg15))
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType>
    MemberFunctionAdaptorObjectByRef<ReturnType,
				     ReturnType (ObjectType::*)() const>
    constMemberFunctionObjectByRef(ReturnType (ObjectType::*fun)() const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1>
    MemberFunctionAdaptorObjectByRef<ReturnType,
				     ReturnType (ObjectType::*)(Arg1) const>
    constMemberFunctionObjectByRef(ReturnType (ObjectType::*fun)(Arg1) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2>
    MemberFunctionAdaptorObjectByRef<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2) const>
    constMemberFunctionObjectByRef(ReturnType (ObjectType::*fun)(Arg1,Arg2) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3>
    MemberFunctionAdaptorObjectByRef<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3) const>
    constMemberFunctionObjectByRef(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4>
    MemberFunctionAdaptorObjectByRef<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4) const>
    constMemberFunctionObjectByRef(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5>
    MemberFunctionAdaptorObjectByRef<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5) const>
    constMemberFunctionObjectByRef(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6>
    MemberFunctionAdaptorObjectByRef<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6) const>
    constMemberFunctionObjectByRef(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7>
    MemberFunctionAdaptorObjectByRef<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7) const>
    constMemberFunctionObjectByRef(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8>
    MemberFunctionAdaptorObjectByRef<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8) const>
    constMemberFunctionObjectByRef(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9>
    MemberFunctionAdaptorObjectByRef<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9) const>
    constMemberFunctionObjectByRef(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10>
    MemberFunctionAdaptorObjectByRef<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10) const>
    constMemberFunctionObjectByRef(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11>
    MemberFunctionAdaptorObjectByRef<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								Arg11) const>
    constMemberFunctionObjectByRef(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								 Arg11) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12>
    MemberFunctionAdaptorObjectByRef<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								Arg11,Arg12) const>
    constMemberFunctionObjectByRef(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								 Arg11,Arg12) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13>
    MemberFunctionAdaptorObjectByRef<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								Arg11,Arg12,Arg13) const>
    constMemberFunctionObjectByRef(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								 Arg11,Arg12,Arg13) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14>
    MemberFunctionAdaptorObjectByRef<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								Arg11,Arg12,Arg13,Arg14) const>
    constMemberFunctionObjectByRef(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								 Arg11,Arg12,Arg13,Arg14) const)
    {
	return fun;
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15>
    MemberFunctionAdaptorObjectByRef<ReturnType,
				     ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								Arg11,Arg12,Arg13,Arg14,Arg15) const>
    constMemberFunctionObjectByRef(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
								 Arg11,Arg12,Arg13,Arg14,Arg15) const)
    {
	return fun;
    }

    // helper functions for binders
    template<typename FunctorType,
	     typename Arg>
    Binder1st<typename FunctorType::return_type,
	      FunctorType,
	      Arg>
    bind1st(FunctorType fun,
	    Arg arg)
    {
	return Binder1st<typename FunctorType::return_type,
	    FunctorType,
	    Arg>(fun,arg);
    }
    template<typename FunctorType,
	     typename Arg>
    Binder2nd<typename FunctorType::return_type,
	      FunctorType,
	      Arg>
    bind2nd(FunctorType fun,
	    Arg arg)
    {
	return Binder2nd<typename FunctorType::return_type,
	    FunctorType,
	    Arg>(fun,arg);
    }
    template<typename FunctorType,
	     typename Arg>
    Binder3rd<typename FunctorType::return_type,
	      FunctorType,
	      Arg>
    bind3rd(FunctorType fun,
	    Arg arg)
    {
	return Binder3rd<typename FunctorType::return_type,
	    FunctorType,
	    Arg>(fun,arg);
    }
    template<typename FunctorType,
	     typename Arg>
    Binder4th<typename FunctorType::return_type,
	      FunctorType,
	      Arg>
    bind4th(FunctorType fun,
	    Arg arg)
    {
	return Binder4th<typename FunctorType::return_type,
	    FunctorType,
	    Arg>(fun,arg);
    }
    template<typename FunctorType,
	     typename Arg>
    Binder5th<typename FunctorType::return_type,
	      FunctorType,
	      Arg>
    bind5th(FunctorType fun,
	    Arg arg)
    {
	return Binder5th<typename FunctorType::return_type,
	    FunctorType,
	    Arg>(fun,arg);
    }
    template<typename FunctorType,
	     typename Arg>
    Binder6th<typename FunctorType::return_type,
	      FunctorType,
	      Arg>
    bind6th(FunctorType fun,
	    Arg arg)
    {
	return Binder6th<typename FunctorType::return_type,
	    FunctorType,
	    Arg>(fun,arg);
    }
    template<typename FunctorType,
	     typename Arg>
    Binder7th<typename FunctorType::return_type,
	      FunctorType,
	      Arg>
    bind7th(FunctorType fun,
	    Arg arg)
    {
	return Binder7th<typename FunctorType::return_type,
	    FunctorType,
	    Arg>(fun,arg);
    }
    template<typename FunctorType,
	     typename Arg>
    Binder8th<typename FunctorType::return_type,
	      FunctorType,
	      Arg>
    bind8th(FunctorType fun,
	    Arg arg)
    {
	return Binder8th<typename FunctorType::return_type,
	    FunctorType,
	    Arg>(fun,arg);
    }
    template<typename FunctorType,
	     typename Arg>
    Binder9th<typename FunctorType::return_type,
	      FunctorType,
	      Arg>
    bind9th(FunctorType fun,
	    Arg arg)
    {
	return Binder9th<typename FunctorType::return_type,
	    FunctorType,
	    Arg>(fun,arg);
    }
    template<typename FunctorType,
	     typename Arg>
    Binder10th<typename FunctorType::return_type,
	      FunctorType,
	      Arg>
    bind10th(FunctorType fun,
	    Arg arg)
    {
	return Binder10th<typename FunctorType::return_type,
	    FunctorType,
	    Arg>(fun,arg);
    }
    template<typename FunctorType,
	     typename Arg>
    Binder11th<typename FunctorType::return_type,
	      FunctorType,
	      Arg>
    bind11th(FunctorType fun,
	    Arg arg)
    {
	return Binder11th<typename FunctorType::return_type,
	    FunctorType,
	    Arg>(fun,arg);
    }
    template<typename FunctorType,
	     typename Arg>
    Binder12th<typename FunctorType::return_type,
	      FunctorType,
	      Arg>
    bind12th(FunctorType fun,
	    Arg arg)
    {
	return Binder12th<typename FunctorType::return_type,
	    FunctorType,
	    Arg>(fun,arg);
    }
    template<typename FunctorType,
	     typename Arg>
    Binder13th<typename FunctorType::return_type,
	      FunctorType,
	      Arg>
    bind13th(FunctorType fun,
	    Arg arg)
    {
	return Binder13th<typename FunctorType::return_type,
	    FunctorType,
	    Arg>(fun,arg);
    }
    template<typename FunctorType,
	     typename Arg>
    Binder14th<typename FunctorType::return_type,
	      FunctorType,
	      Arg>
    bind14th(FunctorType fun,
	    Arg arg)
    {
	return Binder14th<typename FunctorType::return_type,
	    FunctorType,
	    Arg>(fun,arg);
    }
    template<typename FunctorType,
	     typename Arg>
    Binder15th<typename FunctorType::return_type,
	      FunctorType,
	      Arg>
    bind15th(FunctorType fun,
	    Arg arg)
    {
	return Binder15th<typename FunctorType::return_type,
	    FunctorType,
	    Arg>(fun,arg);
    }
    template<typename FunctorType,
	     typename Arg>
    Binder16th<typename FunctorType::return_type,
	      FunctorType,
	      Arg>
    bind16th(FunctorType fun,
	    Arg arg)
    {
	return Binder16th<typename FunctorType::return_type,
	    FunctorType,
	    Arg>(fun,arg);
    }

    // bind arguments by reference
    template<typename FunctorType,
	     typename Arg>
    Binder1st<typename FunctorType::return_type,
	      FunctorType,
	      RefHolder<Arg> >
    bind1stByRef(FunctorType fun,
	    Arg& arg)
    {
	return Binder1st<typename FunctorType::return_type,
	    FunctorType,
	    RefHolder<Arg> >(fun,arg);
    }
    template<typename FunctorType,
	     typename Arg>
    Binder2nd<typename FunctorType::return_type,
	      FunctorType,
	      RefHolder<Arg> >
    bind2ndByRef(FunctorType fun,
	    Arg& arg)
    {
	return Binder2nd<typename FunctorType::return_type,
	    FunctorType,
	    RefHolder<Arg> >(fun,arg);
    }
    template<typename FunctorType,
	     typename Arg>
    Binder3rd<typename FunctorType::return_type,
	      FunctorType,
	      RefHolder<Arg> >
    bind3rdByRef(FunctorType fun,
	    Arg& arg)
    {
	return Binder3rd<typename FunctorType::return_type,
	    FunctorType,
	    RefHolder<Arg> >(fun,arg);
    }
    template<typename FunctorType,
	     typename Arg>
    Binder4th<typename FunctorType::return_type,
	      FunctorType,
	      RefHolder<Arg> >
    bind4thByRef(FunctorType fun,
	    Arg& arg)
    {
	return Binder4th<typename FunctorType::return_type,
	    FunctorType,
	    RefHolder<Arg> >(fun,arg);
    }
    template<typename FunctorType,
	     typename Arg>
    Binder5th<typename FunctorType::return_type,
	      FunctorType,
	      RefHolder<Arg> >
    bind5thByRef(FunctorType fun,
	    Arg& arg)
    {
	return Binder5th<typename FunctorType::return_type,
	    FunctorType,
	    RefHolder<Arg> >(fun,arg);
    }
    template<typename FunctorType,
	     typename Arg>
    Binder6th<typename FunctorType::return_type,
	      FunctorType,
	      RefHolder<Arg> >
    bind6thByRef(FunctorType fun,
	    Arg& arg)
    {
	return Binder6th<typename FunctorType::return_type,
	    FunctorType,
	    RefHolder<Arg> >(fun,arg);
    }
    template<typename FunctorType,
	     typename Arg>
    Binder7th<typename FunctorType::return_type,
	      FunctorType,
	      RefHolder<Arg> >
    bind7thByRef(FunctorType fun,
	    Arg& arg)
    {
	return Binder7th<typename FunctorType::return_type,
	    FunctorType,
	    RefHolder<Arg> >(fun,arg);
    }
    template<typename FunctorType,
	     typename Arg>
    Binder8th<typename FunctorType::return_type,
	      FunctorType,
	      RefHolder<Arg> >
    bind8thByRef(FunctorType fun,
	    Arg& arg)
    {
	return Binder8th<typename FunctorType::return_type,
	    FunctorType,
	    RefHolder<Arg> >(fun,arg);
    }
    template<typename FunctorType,
	     typename Arg>
    Binder9th<typename FunctorType::return_type,
	      FunctorType,
	      RefHolder<Arg> >
    bind9thByRef(FunctorType fun,
	    Arg& arg)
    {
	return Binder9th<typename FunctorType::return_type,
	    FunctorType,
	    RefHolder<Arg> >(fun,arg);
    }
    template<typename FunctorType,
	     typename Arg>
    Binder10th<typename FunctorType::return_type,
	      FunctorType,
	      RefHolder<Arg> >
    bind10thByRef(FunctorType fun,
	    Arg& arg)
    {
	return Binder10th<typename FunctorType::return_type,
	    FunctorType,
	    RefHolder<Arg> >(fun,arg);
    }
    template<typename FunctorType,
	     typename Arg>
    Binder11th<typename FunctorType::return_type,
	      FunctorType,
	      RefHolder<Arg> >
    bind11thByRef(FunctorType fun,
	    Arg& arg)
    {
	return Binder11th<typename FunctorType::return_type,
	    FunctorType,
	    RefHolder<Arg> >(fun,arg);
    }
    template<typename FunctorType,
	     typename Arg>
    Binder12th<typename FunctorType::return_type,
	      FunctorType,
	      RefHolder<Arg> >
    bind12thByRef(FunctorType fun,
	    Arg& arg)
    {
	return Binder12th<typename FunctorType::return_type,
	    FunctorType,
	    RefHolder<Arg> >(fun,arg);
    }
    template<typename FunctorType,
	     typename Arg>
    Binder13th<typename FunctorType::return_type,
	      FunctorType,
	      RefHolder<Arg> >
    bind13thByRef(FunctorType fun,
	    Arg& arg)
    {
	return Binder13th<typename FunctorType::return_type,
	    FunctorType,
	    RefHolder<Arg> >(fun,arg);
    }
    template<typename FunctorType,
	     typename Arg>
    Binder14th<typename FunctorType::return_type,
	      FunctorType,
	      RefHolder<Arg> >
    bind14thByRef(FunctorType fun,
	    Arg& arg)
    {
	return Binder14th<typename FunctorType::return_type,
	    FunctorType,
	    RefHolder<Arg> >(fun,arg);
    }
    template<typename FunctorType,
	     typename Arg>
    Binder15th<typename FunctorType::return_type,
	      FunctorType,
	      RefHolder<Arg> >
    bind15thByRef(FunctorType fun,
	    Arg& arg)
    {
	return Binder15th<typename FunctorType::return_type,
	    FunctorType,
	    RefHolder<Arg> >(fun,arg);
    }
    template<typename FunctorType,
	     typename Arg>
    Binder16th<typename FunctorType::return_type,
	      FunctorType,
	      RefHolder<Arg> >
    bind16thByRef(FunctorType fun,
	    Arg& arg)
    {
	return Binder16th<typename FunctorType::return_type,
	    FunctorType,
	    RefHolder<Arg> >(fun,arg);
    }

}

#endif
