#ifndef FUNCTIONAL_REFHOLDER_HH
#define FUNCTIONAL_REFHOLDER_HH

// functional programming classes
// Copyright 2001 Anthony Williams

namespace functional
{
    // for passing by reference
    template<typename T>
    class RefHolder
    {
    public:
	RefHolder(T& ref_):
	    ref(ref_)
	{}
	operator T&() const
	{
	    return ref;
	}
    private:
	T& ref;
    };

    template<typename T>
    RefHolder<T> byRef(T& ref)
    {
	return ref;
    }
}

#endif
