#ifndef FUNCTIONAL_HELPERS_BIND_ADAPT_HH
#define FUNCTIONAL_HELPERS_BIND_ADAPT_HH

// functional programming helper functions
// Copyright 2001 Anthony Williams

#include "functional_classes.hh"
#include "functional_refholder.hh"
#include "functional_helpers.hh"

namespace functional
{
    // helper functions to bind and adapt in one go
    template<typename ReturnType,
	     typename Arg1,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1)>,
	      BoundObjectType>
    bind1st(ReturnType (*fun)(Arg1),BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2)>,
	      BoundObjectType>
    bind1st(ReturnType (*fun)(Arg1,Arg2),BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3)>,
	      BoundObjectType>
    bind1st(ReturnType (*fun)(Arg1,Arg2,Arg3),BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4)>,
	      BoundObjectType>
    bind1st(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4),BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5)>,
	      BoundObjectType>
    bind1st(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5),BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6)>,
	      BoundObjectType>
    bind1st(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6),BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7)>,
	      BoundObjectType>
    bind1st(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7),BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8)>,
	      BoundObjectType>
    bind1st(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8),BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9)>,
	      BoundObjectType>
    bind1st(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9),BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10)>,
	      BoundObjectType>
    bind1st(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10),BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11)>,
	      BoundObjectType>
    bind1st(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11),BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12)>,
	      BoundObjectType>
    bind1st(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12),BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13)>,
	      BoundObjectType>
    bind1st(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13),BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13,Arg14)>,
	      BoundObjectType>
    bind1st(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13,Arg14),BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13,Arg14,Arg15)>,
	      BoundObjectType>
    bind1st(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13,Arg14,Arg15),BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1)>,
	      BoundObjectType>
    bind1st(ReturnType (ObjectType::*fun)(Arg1),BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2)>,
	      BoundObjectType>
    bind1st(ReturnType (ObjectType::*fun)(Arg1,Arg2),BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3)>,
	      BoundObjectType>
    bind1st(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3),BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4)>,
	      BoundObjectType>
    bind1st(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4),BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5)>,
	      BoundObjectType>
    bind1st(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5),BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6)>,
	      BoundObjectType>
    bind1st(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6),BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7)>,
	      BoundObjectType>
    bind1st(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7),BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8)>,
	      BoundObjectType>
    bind1st(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8),BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9)>,
	      BoundObjectType>
    bind1st(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9),BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10)>,
	      BoundObjectType>
    bind1st(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10),BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11)>,
	      BoundObjectType>
    bind1st(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11),BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12)>,
	      BoundObjectType>
    bind1st(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12),BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13)>,
	      BoundObjectType>
    bind1st(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13),BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14)>,
	      BoundObjectType>
    bind1st(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14),BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14,Arg15)>,
	      BoundObjectType>
    bind1st(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14,Arg15),BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1) const>,
	      BoundObjectType>
    bind1st(ReturnType (ObjectType::*fun)(Arg1) const,BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2) const>,
	      BoundObjectType>
    bind1st(ReturnType (ObjectType::*fun)(Arg1,Arg2) const,BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3) const>,
	      BoundObjectType>
    bind1st(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3) const,BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4) const>,
	      BoundObjectType>
    bind1st(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4) const,BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5) const>,
	      BoundObjectType>
    bind1st(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5) const,BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6) const>,
	      BoundObjectType>
    bind1st(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6) const,BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7) const>,
	      BoundObjectType>
    bind1st(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7) const,BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8) const>,
	      BoundObjectType>
    bind1st(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8) const,BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9) const>,
	      BoundObjectType>
    bind1st(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9) const,BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10) const>,
	      BoundObjectType>
    bind1st(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10) const,BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11) const>,
	      BoundObjectType>
    bind1st(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11) const,BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12) const>,
	      BoundObjectType>
    bind1st(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12) const,BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13) const>,
	      BoundObjectType>
    bind1st(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13) const,BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14) const>,
	      BoundObjectType>
    bind1st(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14) const,BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder1st<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14,Arg15) const>,
	      BoundObjectType>
    bind1st(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14,Arg15) const,BoundObjectType arg)
    {
	return bind1st(functor(fun),arg);
    }

    template<typename ReturnType,
	     typename Arg1,typename Arg2,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2)>,
	      BoundObjectType>
    bind2nd(ReturnType (*fun)(Arg1,Arg2),BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3)>,
	      BoundObjectType>
    bind2nd(ReturnType (*fun)(Arg1,Arg2,Arg3),BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4)>,
	      BoundObjectType>
    bind2nd(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4),BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5)>,
	      BoundObjectType>
    bind2nd(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5),BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6)>,
	      BoundObjectType>
    bind2nd(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6),BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7)>,
	      BoundObjectType>
    bind2nd(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7),BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8)>,
	      BoundObjectType>
    bind2nd(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8),BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9)>,
	      BoundObjectType>
    bind2nd(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9),BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10)>,
	      BoundObjectType>
    bind2nd(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10),BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11)>,
	      BoundObjectType>
    bind2nd(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11),BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12)>,
	      BoundObjectType>
    bind2nd(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12),BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13)>,
	      BoundObjectType>
    bind2nd(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13),BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13,Arg14)>,
	      BoundObjectType>
    bind2nd(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13,Arg14),BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13,Arg14,Arg15)>,
	      BoundObjectType>
    bind2nd(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13,Arg14,Arg15),BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2)>,
	      BoundObjectType>
    bind2nd(ReturnType (ObjectType::*fun)(Arg1,Arg2),BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3)>,
	      BoundObjectType>
    bind2nd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3),BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4)>,
	      BoundObjectType>
    bind2nd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4),BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5)>,
	      BoundObjectType>
    bind2nd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5),BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6)>,
	      BoundObjectType>
    bind2nd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6),BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7)>,
	      BoundObjectType>
    bind2nd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7),BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8)>,
	      BoundObjectType>
    bind2nd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8),BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9)>,
	      BoundObjectType>
    bind2nd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9),BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10)>,
	      BoundObjectType>
    bind2nd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10),BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11)>,
	      BoundObjectType>
    bind2nd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11),BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12)>,
	      BoundObjectType>
    bind2nd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12),BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13)>,
	      BoundObjectType>
    bind2nd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13),BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14)>,
	      BoundObjectType>
    bind2nd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14),BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14,Arg15)>,
	      BoundObjectType>
    bind2nd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14,Arg15),BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2) const>,
	      BoundObjectType>
    bind2nd(ReturnType (ObjectType::*fun)(Arg1,Arg2) const,BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3) const>,
	      BoundObjectType>
    bind2nd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3) const,BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4) const>,
	      BoundObjectType>
    bind2nd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4) const,BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5) const>,
	      BoundObjectType>
    bind2nd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5) const,BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6) const>,
	      BoundObjectType>
    bind2nd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6) const,BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7) const>,
	      BoundObjectType>
    bind2nd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7) const,BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8) const>,
	      BoundObjectType>
    bind2nd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8) const,BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9) const>,
	      BoundObjectType>
    bind2nd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9) const,BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10) const>,
	      BoundObjectType>
    bind2nd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10) const,BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11) const>,
	      BoundObjectType>
    bind2nd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11) const,BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12) const>,
	      BoundObjectType>
    bind2nd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12) const,BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13) const>,
	      BoundObjectType>
    bind2nd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13) const,BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14) const>,
	      BoundObjectType>
    bind2nd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14) const,BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder2nd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14,Arg15) const>,
	      BoundObjectType>
    bind2nd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14,Arg15) const,BoundObjectType arg)
    {
	return bind2nd(functor(fun),arg);
    }
    
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3)>,
	      BoundObjectType>
    bind3rd(ReturnType (*fun)(Arg1,Arg2,Arg3),BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4)>,
	      BoundObjectType>
    bind3rd(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4),BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5)>,
	      BoundObjectType>
    bind3rd(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5),BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6)>,
	      BoundObjectType>
    bind3rd(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6),BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7)>,
	      BoundObjectType>
    bind3rd(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7),BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8)>,
	      BoundObjectType>
    bind3rd(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8),BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9)>,
	      BoundObjectType>
    bind3rd(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9),BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10)>,
	      BoundObjectType>
    bind3rd(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10),BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11)>,
	      BoundObjectType>
    bind3rd(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11),BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12)>,
	      BoundObjectType>
    bind3rd(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12),BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13)>,
	      BoundObjectType>
    bind3rd(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13),BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13,Arg14)>,
	      BoundObjectType>
    bind3rd(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13,Arg14),BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13,Arg14,Arg15)>,
	      BoundObjectType>
    bind3rd(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13,Arg14,Arg15),BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3)>,
	      BoundObjectType>
    bind3rd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3),BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4)>,
	      BoundObjectType>
    bind3rd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4),BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5)>,
	      BoundObjectType>
    bind3rd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5),BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6)>,
	      BoundObjectType>
    bind3rd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6),BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7)>,
	      BoundObjectType>
    bind3rd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7),BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8)>,
	      BoundObjectType>
    bind3rd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8),BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9)>,
	      BoundObjectType>
    bind3rd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9),BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10)>,
	      BoundObjectType>
    bind3rd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10),BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11)>,
	      BoundObjectType>
    bind3rd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11),BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12)>,
	      BoundObjectType>
    bind3rd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12),BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13)>,
	      BoundObjectType>
    bind3rd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13),BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14)>,
	      BoundObjectType>
    bind3rd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14),BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14,Arg15)>,
	      BoundObjectType>
    bind3rd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14,Arg15),BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3) const>,
	      BoundObjectType>
    bind3rd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3) const,BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4) const>,
	      BoundObjectType>
    bind3rd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4) const,BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5) const>,
	      BoundObjectType>
    bind3rd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5) const,BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6) const>,
	      BoundObjectType>
    bind3rd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6) const,BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7) const>,
	      BoundObjectType>
    bind3rd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7) const,BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8) const>,
	      BoundObjectType>
    bind3rd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8) const,BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9) const>,
	      BoundObjectType>
    bind3rd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9) const,BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10) const>,
	      BoundObjectType>
    bind3rd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10) const,BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11) const>,
	      BoundObjectType>
    bind3rd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11) const,BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12) const>,
	      BoundObjectType>
    bind3rd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12) const,BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13) const>,
	      BoundObjectType>
    bind3rd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13) const,BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14) const>,
	      BoundObjectType>
    bind3rd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14) const,BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder3rd<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14,Arg15) const>,
	      BoundObjectType>
    bind3rd(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14,Arg15) const,BoundObjectType arg)
    {
	return bind3rd(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4)>,
	      BoundObjectType>
    bind4th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4),BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5)>,
	      BoundObjectType>
    bind4th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5),BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6)>,
	      BoundObjectType>
    bind4th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6),BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7)>,
	      BoundObjectType>
    bind4th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7),BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8)>,
	      BoundObjectType>
    bind4th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8),BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9)>,
	      BoundObjectType>
    bind4th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9),BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10)>,
	      BoundObjectType>
    bind4th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10),BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11)>,
	      BoundObjectType>
    bind4th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11),BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12)>,
	      BoundObjectType>
    bind4th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12),BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13)>,
	      BoundObjectType>
    bind4th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13),BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13,Arg14)>,
	      BoundObjectType>
    bind4th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13,Arg14),BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13,Arg14,Arg15)>,
	      BoundObjectType>
    bind4th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13,Arg14,Arg15),BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4)>,
	      BoundObjectType>
    bind4th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4),BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5)>,
	      BoundObjectType>
    bind4th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5),BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6)>,
	      BoundObjectType>
    bind4th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6),BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7)>,
	      BoundObjectType>
    bind4th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7),BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8)>,
	      BoundObjectType>
    bind4th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8),BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9)>,
	      BoundObjectType>
    bind4th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9),BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10)>,
	      BoundObjectType>
    bind4th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10),BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11)>,
	      BoundObjectType>
    bind4th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11),BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12)>,
	      BoundObjectType>
    bind4th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12),BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13)>,
	      BoundObjectType>
    bind4th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13),BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14)>,
	      BoundObjectType>
    bind4th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14),BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14,Arg15)>,
	      BoundObjectType>
    bind4th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14,Arg15),BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4) const>,
	      BoundObjectType>
    bind4th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4) const,BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5) const>,
	      BoundObjectType>
    bind4th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5) const,BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6) const>,
	      BoundObjectType>
    bind4th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6) const,BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7) const>,
	      BoundObjectType>
    bind4th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7) const,BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8) const>,
	      BoundObjectType>
    bind4th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8) const,BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9) const>,
	      BoundObjectType>
    bind4th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9) const,BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10) const>,
	      BoundObjectType>
    bind4th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10) const,BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11) const>,
	      BoundObjectType>
    bind4th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11) const,BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12) const>,
	      BoundObjectType>
    bind4th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12) const,BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13) const>,
	      BoundObjectType>
    bind4th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13) const,BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14) const>,
	      BoundObjectType>
    bind4th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14) const,BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder4th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14,Arg15) const>,
	      BoundObjectType>
    bind4th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14,Arg15) const,BoundObjectType arg)
    {
	return bind4th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename BoundObjectType>
    Binder5th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5)>,
	      BoundObjectType>
    bind5th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5),BoundObjectType arg)
    {
	return bind5th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,
	     typename BoundObjectType>
    Binder5th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6)>,
	      BoundObjectType>
    bind5th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6),BoundObjectType arg)
    {
	return bind5th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,
	     typename BoundObjectType>
    Binder5th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7)>,
	      BoundObjectType>
    bind5th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7),BoundObjectType arg)
    {
	return bind5th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,
	     typename BoundObjectType>
    Binder5th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8)>,
	      BoundObjectType>
    bind5th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8),BoundObjectType arg)
    {
	return bind5th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,
	     typename BoundObjectType>
    Binder5th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9)>,
	      BoundObjectType>
    bind5th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9),BoundObjectType arg)
    {
	return bind5th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename BoundObjectType>
    Binder5th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10)>,
	      BoundObjectType>
    bind5th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10),BoundObjectType arg)
    {
	return bind5th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,
	     typename BoundObjectType>
    Binder5th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11)>,
	      BoundObjectType>
    bind5th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11),BoundObjectType arg)
    {
	return bind5th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder5th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12)>,
	      BoundObjectType>
    bind5th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12),BoundObjectType arg)
    {
	return bind5th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder5th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13)>,
	      BoundObjectType>
    bind5th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13),BoundObjectType arg)
    {
	return bind5th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder5th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13,Arg14)>,
	      BoundObjectType>
    bind5th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13,Arg14),BoundObjectType arg)
    {
	return bind5th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder5th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13,Arg14,Arg15)>,
	      BoundObjectType>
    bind5th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13,Arg14,Arg15),BoundObjectType arg)
    {
	return bind5th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename BoundObjectType>
    Binder5th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5)>,
	      BoundObjectType>
    bind5th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5),BoundObjectType arg)
    {
	return bind5th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,
	     typename BoundObjectType>
    Binder5th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6)>,
	      BoundObjectType>
    bind5th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6),BoundObjectType arg)
    {
	return bind5th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,
	     typename BoundObjectType>
    Binder5th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7)>,
	      BoundObjectType>
    bind5th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7),BoundObjectType arg)
    {
	return bind5th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,
	     typename BoundObjectType>
    Binder5th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8)>,
	      BoundObjectType>
    bind5th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8),BoundObjectType arg)
    {
	return bind5th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,
	     typename BoundObjectType>
    Binder5th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9)>,
	      BoundObjectType>
    bind5th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9),BoundObjectType arg)
    {
	return bind5th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename BoundObjectType>
    Binder5th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10)>,
	      BoundObjectType>
    bind5th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10),BoundObjectType arg)
    {
	return bind5th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,
	     typename BoundObjectType>
    Binder5th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11)>,
	      BoundObjectType>
    bind5th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11),BoundObjectType arg)
    {
	return bind5th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder5th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12)>,
	      BoundObjectType>
    bind5th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12),BoundObjectType arg)
    {
	return bind5th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder5th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13)>,
	      BoundObjectType>
    bind5th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13),BoundObjectType arg)
    {
	return bind5th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder5th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14)>,
	      BoundObjectType>
    bind5th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14),BoundObjectType arg)
    {
	return bind5th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder5th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14,Arg15)>,
	      BoundObjectType>
    bind5th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14,Arg15),BoundObjectType arg)
    {
	return bind5th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename BoundObjectType>
    Binder5th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5) const>,
	      BoundObjectType>
    bind5th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5) const,BoundObjectType arg)
    {
	return bind5th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,
	     typename BoundObjectType>
    Binder5th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6) const>,
	      BoundObjectType>
    bind5th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6) const,BoundObjectType arg)
    {
	return bind5th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,
	     typename BoundObjectType>
    Binder5th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7) const>,
	      BoundObjectType>
    bind5th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7) const,BoundObjectType arg)
    {
	return bind5th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,
	     typename BoundObjectType>
    Binder5th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8) const>,
	      BoundObjectType>
    bind5th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8) const,BoundObjectType arg)
    {
	return bind5th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,
	     typename BoundObjectType>
    Binder5th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9) const>,
	      BoundObjectType>
    bind5th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9) const,BoundObjectType arg)
    {
	return bind5th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename BoundObjectType>
    Binder5th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10) const>,
	      BoundObjectType>
    bind5th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10) const,BoundObjectType arg)
    {
	return bind5th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,
	     typename BoundObjectType>
    Binder5th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11) const>,
	      BoundObjectType>
    bind5th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11) const,BoundObjectType arg)
    {
	return bind5th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder5th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12) const>,
	      BoundObjectType>
    bind5th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12) const,BoundObjectType arg)
    {
	return bind5th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder5th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13) const>,
	      BoundObjectType>
    bind5th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13) const,BoundObjectType arg)
    {
	return bind5th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder5th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14) const>,
	      BoundObjectType>
    bind5th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14) const,BoundObjectType arg)
    {
	return bind5th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder5th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14,Arg15) const>,
	      BoundObjectType>
    bind5th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14,Arg15) const,BoundObjectType arg)
    {
	return bind5th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,
	     typename BoundObjectType>
    Binder6th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6)>,
	      BoundObjectType>
    bind6th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6),BoundObjectType arg)
    {
	return bind6th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,
	     typename BoundObjectType>
    Binder6th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7)>,
	      BoundObjectType>
    bind6th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7),BoundObjectType arg)
    {
	return bind6th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,
	     typename BoundObjectType>
    Binder6th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8)>,
	      BoundObjectType>
    bind6th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8),BoundObjectType arg)
    {
	return bind6th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,
	     typename BoundObjectType>
    Binder6th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9)>,
	      BoundObjectType>
    bind6th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9),BoundObjectType arg)
    {
	return bind6th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename BoundObjectType>
    Binder6th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10)>,
	      BoundObjectType>
    bind6th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10),BoundObjectType arg)
    {
	return bind6th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,
	     typename BoundObjectType>
    Binder6th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11)>,
	      BoundObjectType>
    bind6th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11),BoundObjectType arg)
    {
	return bind6th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder6th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12)>,
	      BoundObjectType>
    bind6th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12),BoundObjectType arg)
    {
	return bind6th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder6th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13)>,
	      BoundObjectType>
    bind6th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13),BoundObjectType arg)
    {
	return bind6th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder6th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13,Arg14)>,
	      BoundObjectType>
    bind6th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13,Arg14),BoundObjectType arg)
    {
	return bind6th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder6th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13,Arg14,Arg15)>,
	      BoundObjectType>
    bind6th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13,Arg14,Arg15),BoundObjectType arg)
    {
	return bind6th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,
	     typename BoundObjectType>
    Binder6th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6)>,
	      BoundObjectType>
    bind6th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6),BoundObjectType arg)
    {
	return bind6th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,
	     typename BoundObjectType>
    Binder6th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7)>,
	      BoundObjectType>
    bind6th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7),BoundObjectType arg)
    {
	return bind6th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,
	     typename BoundObjectType>
    Binder6th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8)>,
	      BoundObjectType>
    bind6th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8),BoundObjectType arg)
    {
	return bind6th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,
	     typename BoundObjectType>
    Binder6th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9)>,
	      BoundObjectType>
    bind6th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9),BoundObjectType arg)
    {
	return bind6th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename BoundObjectType>
    Binder6th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10)>,
	      BoundObjectType>
    bind6th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10),BoundObjectType arg)
    {
	return bind6th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,
	     typename BoundObjectType>
    Binder6th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11)>,
	      BoundObjectType>
    bind6th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11),BoundObjectType arg)
    {
	return bind6th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder6th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12)>,
	      BoundObjectType>
    bind6th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12),BoundObjectType arg)
    {
	return bind6th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder6th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13)>,
	      BoundObjectType>
    bind6th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13),BoundObjectType arg)
    {
	return bind6th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder6th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14)>,
	      BoundObjectType>
    bind6th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14),BoundObjectType arg)
    {
	return bind6th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder6th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14,Arg15)>,
	      BoundObjectType>
    bind6th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14,Arg15),BoundObjectType arg)
    {
	return bind6th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,
	     typename BoundObjectType>
    Binder6th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6) const>,
	      BoundObjectType>
    bind6th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6) const,BoundObjectType arg)
    {
	return bind6th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,
	     typename BoundObjectType>
    Binder6th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7) const>,
	      BoundObjectType>
    bind6th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7) const,BoundObjectType arg)
    {
	return bind6th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,
	     typename BoundObjectType>
    Binder6th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8) const>,
	      BoundObjectType>
    bind6th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8) const,BoundObjectType arg)
    {
	return bind6th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,
	     typename BoundObjectType>
    Binder6th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9) const>,
	      BoundObjectType>
    bind6th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9) const,BoundObjectType arg)
    {
	return bind6th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename BoundObjectType>
    Binder6th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10) const>,
	      BoundObjectType>
    bind6th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10) const,BoundObjectType arg)
    {
	return bind6th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,
	     typename BoundObjectType>
    Binder6th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11) const>,
	      BoundObjectType>
    bind6th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11) const,BoundObjectType arg)
    {
	return bind6th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder6th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12) const>,
	      BoundObjectType>
    bind6th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12) const,BoundObjectType arg)
    {
	return bind6th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder6th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13) const>,
	      BoundObjectType>
    bind6th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13) const,BoundObjectType arg)
    {
	return bind6th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder6th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14) const>,
	      BoundObjectType>
    bind6th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14) const,BoundObjectType arg)
    {
	return bind6th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder6th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14,Arg15) const>,
	      BoundObjectType>
    bind6th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14,Arg15) const,BoundObjectType arg)
    {
	return bind6th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,
	     typename BoundObjectType>
    Binder7th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7)>,
	      BoundObjectType>
    bind7th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7),BoundObjectType arg)
    {
	return bind7th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,
	     typename BoundObjectType>
    Binder7th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8)>,
	      BoundObjectType>
    bind7th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8),BoundObjectType arg)
    {
	return bind7th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,
	     typename BoundObjectType>
    Binder7th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9)>,
	      BoundObjectType>
    bind7th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9),BoundObjectType arg)
    {
	return bind7th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename BoundObjectType>
    Binder7th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10)>,
	      BoundObjectType>
    bind7th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10),BoundObjectType arg)
    {
	return bind7th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,
	     typename BoundObjectType>
    Binder7th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11)>,
	      BoundObjectType>
    bind7th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11),BoundObjectType arg)
    {
	return bind7th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder7th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12)>,
	      BoundObjectType>
    bind7th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12),BoundObjectType arg)
    {
	return bind7th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder7th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13)>,
	      BoundObjectType>
    bind7th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13),BoundObjectType arg)
    {
	return bind7th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder7th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13,Arg14)>,
	      BoundObjectType>
    bind7th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13,Arg14),BoundObjectType arg)
    {
	return bind7th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder7th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13,Arg14,Arg15)>,
	      BoundObjectType>
    bind7th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13,Arg14,Arg15),BoundObjectType arg)
    {
	return bind7th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,
	     typename BoundObjectType>
    Binder7th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7)>,
	      BoundObjectType>
    bind7th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7),BoundObjectType arg)
    {
	return bind7th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,
	     typename BoundObjectType>
    Binder7th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8)>,
	      BoundObjectType>
    bind7th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8),BoundObjectType arg)
    {
	return bind7th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,
	     typename BoundObjectType>
    Binder7th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9)>,
	      BoundObjectType>
    bind7th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9),BoundObjectType arg)
    {
	return bind7th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename BoundObjectType>
    Binder7th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10)>,
	      BoundObjectType>
    bind7th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10),BoundObjectType arg)
    {
	return bind7th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,
	     typename BoundObjectType>
    Binder7th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11)>,
	      BoundObjectType>
    bind7th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11),BoundObjectType arg)
    {
	return bind7th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder7th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12)>,
	      BoundObjectType>
    bind7th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12),BoundObjectType arg)
    {
	return bind7th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder7th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13)>,
	      BoundObjectType>
    bind7th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13),BoundObjectType arg)
    {
	return bind7th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder7th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14)>,
	      BoundObjectType>
    bind7th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14),BoundObjectType arg)
    {
	return bind7th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder7th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14,Arg15)>,
	      BoundObjectType>
    bind7th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14,Arg15),BoundObjectType arg)
    {
	return bind7th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,
	     typename BoundObjectType>
    Binder7th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7) const>,
	      BoundObjectType>
    bind7th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7) const,BoundObjectType arg)
    {
	return bind7th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,
	     typename BoundObjectType>
    Binder7th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8) const>,
	      BoundObjectType>
    bind7th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8) const,BoundObjectType arg)
    {
	return bind7th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,
	     typename BoundObjectType>
    Binder7th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9) const>,
	      BoundObjectType>
    bind7th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9) const,BoundObjectType arg)
    {
	return bind7th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename BoundObjectType>
    Binder7th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10) const>,
	      BoundObjectType>
    bind7th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10) const,BoundObjectType arg)
    {
	return bind7th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,
	     typename BoundObjectType>
    Binder7th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11) const>,
	      BoundObjectType>
    bind7th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11) const,BoundObjectType arg)
    {
	return bind7th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder7th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12) const>,
	      BoundObjectType>
    bind7th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12) const,BoundObjectType arg)
    {
	return bind7th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder7th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13) const>,
	      BoundObjectType>
    bind7th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13) const,BoundObjectType arg)
    {
	return bind7th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder7th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14) const>,
	      BoundObjectType>
    bind7th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14) const,BoundObjectType arg)
    {
	return bind7th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder7th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14,Arg15) const>,
	      BoundObjectType>
    bind7th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14,Arg15) const,BoundObjectType arg)
    {
	return bind7th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,
	     typename BoundObjectType>
    Binder8th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8)>,
	      BoundObjectType>
    bind8th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8),BoundObjectType arg)
    {
	return bind8th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,
	     typename BoundObjectType>
    Binder8th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9)>,
	      BoundObjectType>
    bind8th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9),BoundObjectType arg)
    {
	return bind8th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename BoundObjectType>
    Binder8th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10)>,
	      BoundObjectType>
    bind8th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10),BoundObjectType arg)
    {
	return bind8th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,
	     typename BoundObjectType>
    Binder8th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11)>,
	      BoundObjectType>
    bind8th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11),BoundObjectType arg)
    {
	return bind8th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder8th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12)>,
	      BoundObjectType>
    bind8th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12),BoundObjectType arg)
    {
	return bind8th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder8th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13)>,
	      BoundObjectType>
    bind8th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13),BoundObjectType arg)
    {
	return bind8th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder8th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13,Arg14)>,
	      BoundObjectType>
    bind8th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13,Arg14),BoundObjectType arg)
    {
	return bind8th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder8th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13,Arg14,Arg15)>,
	      BoundObjectType>
    bind8th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13,Arg14,Arg15),BoundObjectType arg)
    {
	return bind8th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,
	     typename BoundObjectType>
    Binder8th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8)>,
	      BoundObjectType>
    bind8th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8),BoundObjectType arg)
    {
	return bind8th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,
	     typename BoundObjectType>
    Binder8th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9)>,
	      BoundObjectType>
    bind8th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9),BoundObjectType arg)
    {
	return bind8th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename BoundObjectType>
    Binder8th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10)>,
	      BoundObjectType>
    bind8th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10),BoundObjectType arg)
    {
	return bind8th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,
	     typename BoundObjectType>
    Binder8th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11)>,
	      BoundObjectType>
    bind8th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11),BoundObjectType arg)
    {
	return bind8th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder8th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12)>,
	      BoundObjectType>
    bind8th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12),BoundObjectType arg)
    {
	return bind8th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder8th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13)>,
	      BoundObjectType>
    bind8th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13),BoundObjectType arg)
    {
	return bind8th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder8th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14)>,
	      BoundObjectType>
    bind8th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14),BoundObjectType arg)
    {
	return bind8th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder8th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14,Arg15)>,
	      BoundObjectType>
    bind8th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14,Arg15),BoundObjectType arg)
    {
	return bind8th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,
	     typename BoundObjectType>
    Binder8th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8) const>,
	      BoundObjectType>
    bind8th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8) const,BoundObjectType arg)
    {
	return bind8th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,
	     typename BoundObjectType>
    Binder8th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9) const>,
	      BoundObjectType>
    bind8th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9) const,BoundObjectType arg)
    {
	return bind8th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename BoundObjectType>
    Binder8th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10) const>,
	      BoundObjectType>
    bind8th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10) const,BoundObjectType arg)
    {
	return bind8th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,
	     typename BoundObjectType>
    Binder8th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11) const>,
	      BoundObjectType>
    bind8th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11) const,BoundObjectType arg)
    {
	return bind8th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder8th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12) const>,
	      BoundObjectType>
    bind8th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12) const,BoundObjectType arg)
    {
	return bind8th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder8th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13) const>,
	      BoundObjectType>
    bind8th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13) const,BoundObjectType arg)
    {
	return bind8th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder8th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14) const>,
	      BoundObjectType>
    bind8th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14) const,BoundObjectType arg)
    {
	return bind8th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder8th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14,Arg15) const>,
	      BoundObjectType>
    bind8th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14,Arg15) const,BoundObjectType arg)
    {
	return bind8th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,
	     typename BoundObjectType>
    Binder9th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9)>,
	      BoundObjectType>
    bind9th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9),BoundObjectType arg)
    {
	return bind9th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename BoundObjectType>
    Binder9th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10)>,
	      BoundObjectType>
    bind9th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10),BoundObjectType arg)
    {
	return bind9th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,
	     typename BoundObjectType>
    Binder9th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11)>,
	      BoundObjectType>
    bind9th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11),BoundObjectType arg)
    {
	return bind9th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder9th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12)>,
	      BoundObjectType>
    bind9th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12),BoundObjectType arg)
    {
	return bind9th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder9th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13)>,
	      BoundObjectType>
    bind9th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13),BoundObjectType arg)
    {
	return bind9th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder9th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13,Arg14)>,
	      BoundObjectType>
    bind9th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13,Arg14),BoundObjectType arg)
    {
	return bind9th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder9th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13,Arg14,Arg15)>,
	      BoundObjectType>
    bind9th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13,Arg14,Arg15),BoundObjectType arg)
    {
	return bind9th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,
	     typename BoundObjectType>
    Binder9th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9)>,
	      BoundObjectType>
    bind9th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9),BoundObjectType arg)
    {
	return bind9th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename BoundObjectType>
    Binder9th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10)>,
	      BoundObjectType>
    bind9th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10),BoundObjectType arg)
    {
	return bind9th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,
	     typename BoundObjectType>
    Binder9th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11)>,
	      BoundObjectType>
    bind9th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11),BoundObjectType arg)
    {
	return bind9th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder9th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12)>,
	      BoundObjectType>
    bind9th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12),BoundObjectType arg)
    {
	return bind9th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder9th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13)>,
	      BoundObjectType>
    bind9th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13),BoundObjectType arg)
    {
	return bind9th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder9th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14)>,
	      BoundObjectType>
    bind9th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14),BoundObjectType arg)
    {
	return bind9th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder9th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14,Arg15)>,
	      BoundObjectType>
    bind9th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14,Arg15),BoundObjectType arg)
    {
	return bind9th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,
	     typename BoundObjectType>
    Binder9th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9) const>,
	      BoundObjectType>
    bind9th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9) const,BoundObjectType arg)
    {
	return bind9th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename BoundObjectType>
    Binder9th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10) const>,
	      BoundObjectType>
    bind9th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10) const,BoundObjectType arg)
    {
	return bind9th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,
	     typename BoundObjectType>
    Binder9th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11) const>,
	      BoundObjectType>
    bind9th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11) const,BoundObjectType arg)
    {
	return bind9th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder9th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12) const>,
	      BoundObjectType>
    bind9th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12) const,BoundObjectType arg)
    {
	return bind9th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder9th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13) const>,
	      BoundObjectType>
    bind9th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13) const,BoundObjectType arg)
    {
	return bind9th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder9th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14) const>,
	      BoundObjectType>
    bind9th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14) const,BoundObjectType arg)
    {
	return bind9th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder9th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14,Arg15) const>,
	      BoundObjectType>
    bind9th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14,Arg15) const,BoundObjectType arg)
    {
	return bind9th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename BoundObjectType>
    Binder10th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10)>,
	      BoundObjectType>
    bind10th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10
			      ),BoundObjectType arg)
    {
	return bind10th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,
	     typename BoundObjectType>
    Binder10th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11)>,
	      BoundObjectType>
    bind10th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11),BoundObjectType arg)
    {
	return bind10th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder10th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12)>,
	      BoundObjectType>
    bind10th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12),BoundObjectType arg)
    {
	return bind10th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder10th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13)>,
	      BoundObjectType>
    bind10th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13),BoundObjectType arg)
    {
	return bind10th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder10th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13,Arg14)>,
	      BoundObjectType>
    bind10th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13,Arg14),BoundObjectType arg)
    {
	return bind10th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder10th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13,Arg14,Arg15)>,
	      BoundObjectType>
    bind10th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13,Arg14,Arg15),BoundObjectType arg)
    {
	return bind10th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename BoundObjectType>
    Binder10th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10)>,
	      BoundObjectType>
    bind10th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10),BoundObjectType arg)
    {
	return bind10th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,
	     typename BoundObjectType>
    Binder10th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11)>,
	      BoundObjectType>
    bind10th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11),BoundObjectType arg)
    {
	return bind10th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder10th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12)>,
	      BoundObjectType>
    bind10th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12),BoundObjectType arg)
    {
	return bind10th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder10th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13)>,
	      BoundObjectType>
    bind10th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13),BoundObjectType arg)
    {
	return bind10th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder10th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14)>,
	      BoundObjectType>
    bind10th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14),BoundObjectType arg)
    {
	return bind10th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder10th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14,Arg15)>,
	      BoundObjectType>
    bind10th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14,Arg15),BoundObjectType arg)
    {
	return bind10th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename BoundObjectType>
    Binder10th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10) const>,
	      BoundObjectType>
    bind10th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10) const,BoundObjectType arg)
    {
	return bind10th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,
	     typename BoundObjectType>
    Binder10th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11) const>,
	      BoundObjectType>
    bind10th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11) const,BoundObjectType arg)
    {
	return bind10th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder10th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12) const>,
	      BoundObjectType>
    bind10th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12) const,BoundObjectType arg)
    {
	return bind10th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder10th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13) const>,
	      BoundObjectType>
    bind10th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13) const,BoundObjectType arg)
    {
	return bind10th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder10th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14) const>,
	      BoundObjectType>
    bind10th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14) const,BoundObjectType arg)
    {
	return bind10th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder10th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14,Arg15) const>,
	      BoundObjectType>
    bind10th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14,Arg15) const,BoundObjectType arg)
    {
	return bind10th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,
	     typename BoundObjectType>
    Binder11th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11)>,
	      BoundObjectType>
    bind11th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11),BoundObjectType arg)
    {
	return bind11th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder11th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12)>,
	      BoundObjectType>
    bind11th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12),BoundObjectType arg)
    {
	return bind11th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder11th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13)>,
	      BoundObjectType>
    bind11th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13),BoundObjectType arg)
    {
	return bind11th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder11th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13,Arg14)>,
	      BoundObjectType>
    bind11th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13,Arg14),BoundObjectType arg)
    {
	return bind11th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder11th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13,Arg14,Arg15)>,
	      BoundObjectType>
    bind11th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13,Arg14,Arg15),BoundObjectType arg)
    {
	return bind11th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,
	     typename BoundObjectType>
    Binder11th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11)>,
	      BoundObjectType>
    bind11th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11),BoundObjectType arg)
    {
	return bind11th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder11th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12)>,
	      BoundObjectType>
    bind11th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12),BoundObjectType arg)
    {
	return bind11th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder11th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13)>,
	      BoundObjectType>
    bind11th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13),BoundObjectType arg)
    {
	return bind11th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder11th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14)>,
	      BoundObjectType>
    bind11th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14),BoundObjectType arg)
    {
	return bind11th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder11th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14,Arg15)>,
	      BoundObjectType>
    bind11th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14,Arg15),BoundObjectType arg)
    {
	return bind11th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,
	     typename BoundObjectType>
    Binder11th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11) const>,
	      BoundObjectType>
    bind11th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11) const,BoundObjectType arg)
    {
	return bind11th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder11th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12) const>,
	      BoundObjectType>
    bind11th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12) const,BoundObjectType arg)
    {
	return bind11th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder11th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13) const>,
	      BoundObjectType>
    bind11th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13) const,BoundObjectType arg)
    {
	return bind11th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder11th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14) const>,
	      BoundObjectType>
    bind11th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14) const,BoundObjectType arg)
    {
	return bind11th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder11th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14,Arg15) const>,
	      BoundObjectType>
    bind11th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14,Arg15) const,BoundObjectType arg)
    {
	return bind11th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder12th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12)>,
	      BoundObjectType>
    bind12th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12),BoundObjectType arg)
    {
	return bind12th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder12th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13)>,
	      BoundObjectType>
    bind12th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13),BoundObjectType arg)
    {
	return bind12th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder12th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13,Arg14)>,
	      BoundObjectType>
    bind12th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13,Arg14),BoundObjectType arg)
    {
	return bind12th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder12th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13,Arg14,Arg15)>,
	      BoundObjectType>
    bind12th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13,Arg14,Arg15),BoundObjectType arg)
    {
	return bind12th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder12th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12)>,
	      BoundObjectType>
    bind12th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12),BoundObjectType arg)
    {
	return bind12th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder12th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13)>,
	      BoundObjectType>
    bind12th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13),BoundObjectType arg)
    {
	return bind12th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder12th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14)>,
	      BoundObjectType>
    bind12th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14),BoundObjectType arg)
    {
	return bind12th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder12th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14,Arg15)>,
	      BoundObjectType>
    bind12th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14,Arg15),BoundObjectType arg)
    {
	return bind12th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,
	     typename BoundObjectType>
    Binder12th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12) const>,
	      BoundObjectType>
    bind12th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12) const,BoundObjectType arg)
    {
	return bind12th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder12th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13) const>,
	      BoundObjectType>
    bind12th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13) const,BoundObjectType arg)
    {
	return bind12th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder12th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14) const>,
	      BoundObjectType>
    bind12th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14) const,BoundObjectType arg)
    {
	return bind12th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder12th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14,Arg15) const>,
	      BoundObjectType>
    bind12th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14,Arg15) const,BoundObjectType arg)
    {
	return bind12th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder13th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13)>,
	      BoundObjectType>
    bind13th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13),BoundObjectType arg)
    {
	return bind13th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder13th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13,Arg14)>,
	      BoundObjectType>
    bind13th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13,Arg14),BoundObjectType arg)
    {
	return bind13th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder13th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13,Arg14,Arg15)>,
	      BoundObjectType>
    bind13th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13,Arg14,Arg15),BoundObjectType arg)
    {
	return bind13th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder13th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13)>,
	      BoundObjectType>
    bind13th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13),BoundObjectType arg)
    {
	return bind13th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder13th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14)>,
	      BoundObjectType>
    bind13th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14),BoundObjectType arg)
    {
	return bind13th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder13th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14,Arg15)>,
	      BoundObjectType>
    bind13th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14,Arg15),BoundObjectType arg)
    {
	return bind13th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,
	     typename BoundObjectType>
    Binder13th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13) const>,
	      BoundObjectType>
    bind13th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13) const,BoundObjectType arg)
    {
	return bind13th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder13th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14) const>,
	      BoundObjectType>
    bind13th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14) const,BoundObjectType arg)
    {
	return bind13th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder13th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14,Arg15) const>,
	      BoundObjectType>
    bind13th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14,Arg15) const,BoundObjectType arg)
    {
	return bind13th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder14th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13,Arg14)>,
	      BoundObjectType>
    bind14th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13,Arg14),BoundObjectType arg)
    {
	return bind14th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder14th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13,Arg14,Arg15)>,
	      BoundObjectType>
    bind14th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13,Arg14,Arg15),BoundObjectType arg)
    {
	return bind14th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder14th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14)>,
	      BoundObjectType>
    bind14th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14),BoundObjectType arg)
    {
	return bind14th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder14th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14,Arg15)>,
	      BoundObjectType>
    bind14th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14,Arg15),BoundObjectType arg)
    {
	return bind14th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,
	     typename BoundObjectType>
    Binder14th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14) const>,
	      BoundObjectType>
    bind14th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14) const,BoundObjectType arg)
    {
	return bind14th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder14th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14,Arg15) const>,
	      BoundObjectType>
    bind14th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14,Arg15) const,BoundObjectType arg)
    {
	return bind14th(functor(fun),arg);
    }
    template<typename ReturnType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder15th<ReturnType,
	      FunctorAdaptor<ReturnType,
			     ReturnType (*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					    Arg11,Arg12,Arg13,Arg14,Arg15)>,
	      BoundObjectType>
    bind15th(ReturnType (*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
			      Arg11,Arg12,Arg13,Arg14,Arg15),BoundObjectType arg)
    {
	return bind15th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder15th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14,Arg15)>,
	      BoundObjectType>
    bind15th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14,Arg15),BoundObjectType arg)
    {
	return bind15th(functor(fun),arg);
    }
    template<typename ReturnType,typename ObjectType,
	     typename Arg1,typename Arg2,typename Arg3,typename Arg4,typename Arg5,
	     typename Arg6,typename Arg7,typename Arg8,typename Arg9,typename Arg10,
	     typename Arg11,typename Arg12,typename Arg13,typename Arg14,typename Arg15,
	     typename BoundObjectType>
    Binder15th<ReturnType,
	      MemberFunctionAdaptorObjectByPtr<ReturnType,
					       ReturnType (ObjectType::*)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
									  Arg11,Arg12,Arg13,Arg14,Arg15) const>,
	      BoundObjectType>
    bind15th(ReturnType (ObjectType::*fun)(Arg1,Arg2,Arg3,Arg4,Arg5,Arg6,Arg7,Arg8,Arg9,Arg10,
					  Arg11,Arg12,Arg13,Arg14,Arg15) const,BoundObjectType arg)
    {
	return bind15th(functor(fun),arg);
    }
}

#endif
